<?php
// $Id: install.php,v 0.8.2 2005-10-12 7:05:14 PM ankur Exp $

/**
 * This function is taken from bootstrap.inc
 * Encode special characters in a plain-text string for display as HTML.
 */
function check_plain($text) {
  return htmlspecialchars($text, ENT_QUOTES);
}

/**
 * Originally update_page_header(), ripped directly from update.php.  Changed a little
 * for install.php.
 */
function install_page_header($title, $percent = NULL) {
  $output = "<html>\n<head>\n<title>CivicSpace installer: ". $title ."</title>\n";
  if (!is_null($percent)) {
    $output .= '<meta http-equiv="refresh" content="0; url=http://'. install_base_uri() .'/install.php?op=continue_dump" />'."\n";
  }
  $output .= <<<EOF
      <link rel="stylesheet" type="text/css" media="screen" href="misc/install/styles.css" title="Installer styles" />
EOF;
  $output .= "</head>\n<body>\n";
  $output .= "<div class=\"hide\">\n";
  $output .= "  <a href=\"#content\" title=\"Skip the site navigation to go directly to the content\" class=\"skiplink\">Skip to content</a>\n";
  $output .= "</div>\n";

  $output .= "<div id=\"header\">\n";
  $output .= "  <div id=\"header-container\">\n";
  $output .= "    <h1 id=\"logo\"><a href=\"http://www.civicspacelabs.org\" class=\"text-replacement\">CivicSpace Labs</a></h1>\n";
  $output .= "    <div id=\"panic\"><a href=\"http://civicspacelabs.org/home/installer_help/082\" class=\"text-replacement\" title=\"Panic!!\" target=\"_blank\">Last resort panic link!</a></div>\n";
  $output .= "  </div>\n";
  $output .= "</div>\n";
  
  $output .= "<div id=\"wrapper\">\n";
  $output .= "<h2 id=\"site-name\">CivicSpace Installer</h2>\n";
  $output .= "<div id=\"content\">\n";

  return $output;
}

/**
 * Also ripped directly from update.php. Yeah, I'm still coding this quickly.
 * And I changed double to single quotes again.
 * Originally update_page_footer().
 */
function install_page_footer() {
  $output  = "</div>\n</div>";
  /* the origional version of this had these non-existant links. they may exist later
  $output .= "<div id=\"notices\">\n";
  $output .= "  <ul class=\"flat-navigation\">\n";
  $output .= '  <li class="first"><a href="http://www.civicspacelabs.org/">civicspace home</a></li>'."\n";
  $output .= '  <li class="last"><a href="http://www.civicspacelabs.org/about">about civicspace</a></li>'."\n";
  $output .= '  <li><a href="http://www.civicspacelabs.org/contact">contact us</a></li>'."\n";
  $output .= '  <li><a href="http://www.civicspacelabs.org/support">get support</a></li>'."\n";
  $output .= '  <li><a href="http://www.civicspacelabs.org/contribute">contribute</a></li>'."\n";
  $output .= '  <li><a href="http://www.civicspacelabs.org/privacy">privacy policy &amp; disclaimers</a></li>'."\n";
  $output .= "  </ul>\n";
  $output .= "</div>\n";
  */
  $output .= "</body>\n</html>\n";
  return $output;
}

// COMMENCE RIPPING FROM COMMON.INC!!

/**
 * Generate a form from a set of form elements.
 *
 * @param $form
 *   An HTML string containing one or more form elements.
 * @param $method
 *   The query method to use ("post" or "get").
 * @param $action
 *   The URL to send the form contents to, if not the current page.
 * @param $attributes
 *   An associative array of attributes to add to the form tag.
 * @result
 *   An HTML string with the contents of $form wrapped in a form tag.
 */
function form($form, $method = 'post', $action = NULL, $attributes = NULL) {
  if (!$action) {
    $action = request_uri();
  }
  return '<form action="'. $action .'" method="'. $method .'"'. drupal_attributes($attributes) .">\n". $form ."\n</form>\n";
}

/**
 * Return an associative array of all errors.
 */
function form_get_errors() {
  if (array_key_exists('form', $GLOBALS)) {
    return $GLOBALS['form'];
  }
}

/**
 * Return the error message filed against the form with the specified name.
 */
function _form_get_error($name) {
  if (array_key_exists('form', $GLOBALS)) {
    return $GLOBALS['form'][$name];
  }
}

function _form_get_class($name, $required, $error) {
  return $name. ($required ? ' required' : '') . ($error ? ' error' : '');
}

/**
 * File an error against the form element with the specified name.
 */
function form_set_error($name, $message) {
  $GLOBALS['form'][$name] = $message;
  drupal_set_message($message, 'error');
}

/**
 * Format a general form item.
 *
 * @param $title
 *   The label for the form item.
 * @param $value
 *   The contents of the form item.
 * @param $description
 *   Explanatory text to display after the form item.
 * @param $id
 *   A unique identifier for the form item.
 * @param $required
 *   Whether the user must fill in this form element before submitting the form.
 * @param $error
 *   An error message to display alongside the form element.
 * @return
 *   A themed HTML string representing the form item.
 */
function form_item($title, $value, $description = NULL, $id = NULL, $required = FALSE, $error = FALSE) {
  return theme('form_element', $title, $value, $description, $id, $required, $error);
}

/**
 * Format a group of form items.
 *
 * @param $legend
 *   The label for the form item group.
 * @param $group
 *   The form items within the group, as an HTML string.
 * @param $description
 *   Explanatory text to display after the form item group.
 * @return
 *   A themed HTML string representing the form item group.
 */
function form_group($legend, $group, $description = NULL) {
  return '<fieldset>' . ($legend ? '<legend>'. $legend .'</legend>' : '') . $group . ($description ? '<div class="description">'. $description .'</div>' : '') . "</fieldset>\n";
}

/**
 * Format a checkbox.
 *
 * @param $title
 *   The label for the checkbox.
 * @param $name
 *   The internal name used to refer to the button.
 * @param $value
 *   The value that the form element takes on when selected.
 * @param $checked
 *   Whether the button will be initially selected when the page is rendered.
 * @param $description
 *   Explanatory text to display after the form item.
 * @param $attributes
 *   An associative array of HTML attributes to add to the button.
 * @param $required
 *   Whether the user must check this box before submitting the form.
 * @return
 *   A themed HTML string representing the checkbox.
 */
function form_checkbox($title, $name, $value = 1, $checked = FALSE, $description = NULL, $attributes = NULL, $required = FALSE) {
  $element = '<input type="checkbox" class="'. _form_get_class('form-checkbox', $required, _form_get_error($name)) .'" name="edit['. $name .']" id="edit-'. $name .'" value="'. $value .'"'. ($checked ? ' checked="checked"' : '') . drupal_attributes($attributes) .' />';
  if (!is_null($title)) {
    $element = '<label class="option">'. $element .' '. $title .'</label>';
  }
  return form_hidden($name, 0) . theme('form_element', NULL, $element, $description, $name, $required, _form_get_error($name));
}

/**
 * Format a single-line text field.
 *
 * @param $title
 *   The label for the text field.
 * @param $name
 *   The internal name used to refer to the field.
 * @param $value
 *   The initial value for the field at page load time.
 * @param $size
 *   A measure of the visible size of the field (passed directly to HTML).
 * @param $maxlength
 *   The maximum number of characters that may be entered in the field.
 * @param $description
 *   Explanatory text to display after the form item.
 * @param $attributes
 *   An associative array of HTML attributes to add to the form item.
 * @param $required
 *   Whether the user must enter some text in the field.
 * @return
 *   A themed HTML string representing the field.
 */
function form_textfield($title, $name, $value, $size, $maxlength, $description = NULL, $attributes = NULL, $required = FALSE) {
  $size = $size ? ' size="'. $size .'"' : '';
  return theme('form_element', $title, '<input type="text" maxlength="'. $maxlength .'" class="'. _form_get_class('form-text', $required, _form_get_error($name)) .'" name="edit['. $name .']" id="edit-'. $name .'"'. $size .' value="'. check_form($value) .'"'. drupal_attributes($attributes) .' />', $description, 'edit-'. $name, $required, _form_get_error($name));
}

/**
 * Format a single-line text field that does not display its contents visibly.
 *
 * @param $title
 *   The label for the text field.
 * @param $name
 *   The internal name used to refer to the field.
 * @param $value
 *   The initial value for the field at page load time.
 * @param $size
 *   A measure of the visible size of the field (passed directly to HTML).
 * @param $maxlength
 *   The maximum number of characters that may be entered in the field.
 * @param $description
 *   Explanatory text to display after the form item.
 * @param $attributes
 *   An associative array of HTML attributes to add to the form item.
 * @param $required
 *   Whether the user must enter some text in the field.
 * @return
 *   A themed HTML string representing the field.
 */
function form_password($title, $name, $value, $size, $maxlength, $description = NULL, $attributes = NULL, $required = FALSE) {
  $size = $size ? ' size="'. $size .'"' : '';
  return theme('form_element', $title, '<input type="password" class="'. _form_get_class('form-password', $required, _form_get_error($name)) .'" maxlength="'. $maxlength .'" name="edit['. $name .']" id="edit-'. $name .'"'. $size .' value="'. check_form($value) .'"'. drupal_attributes($attributes) .' />', $description, 'edit-'. $name, $required, _form_get_error($name));
}

function check_form($text) {
  return drupal_specialchars($text, ENT_QUOTES);
}

/**
 * Store data in a hidden form field.
 *
 * @param $name
 *   The internal name used to refer to the field.
 * @param $value
 *   The stored data.
 * @return
 *   A themed HTML string representing the hidden field.
 *
 * This function can be useful in retaining information between page requests,
 * but be sure to validate the data on the receiving page as it is possible for
 * an attacker to change the value before it is submitted.
 */
function form_hidden($name, $value) {
  return '<input type="hidden" name="edit['. $name .']" value="'. check_form($value) ."\" />\n";
}

/**
 * Format a radio button.
 *
 * @param $title
 *   The label for the radio button.
 * @param $name
 *   The internal name used to refer to the button.
 * @param $value
 *   The value that the form element takes on when selected.
 * @param $checked
 *   Whether the button will be initially selected when the page is rendered.
 * @param $description
 *   Explanatory text to display after the form item.
 * @param $attributes
 *   An associative array of HTML attributes to add to the button.
 * @param $required
 *   Whether the user must select this radio button before submitting the form.
 * @return
 *   A themed HTML string representing the radio button.
 */
function form_radio($title, $name, $value = 1, $checked = FALSE, $description = NULL, $attributes = NULL, $required = FALSE) {
  $element = '<input type="radio" class="'. _form_get_class('form-radio', $required, _form_get_error($name)) .'" name="edit['. $name .']" value="'. $value .'"'. ($checked ? ' checked="checked"' : '') . drupal_attributes($attributes) .' />';
  if (!is_null($title)) {
    $element = '<label class="option">'. $element .' '. $title .'</label>';
  }
  return theme('form_element', NULL, $element, $description, $name, $required, _form_get_error($name));
}

/**
 * Format a set of radio buttons.
 *
 * @param $title
 *   The label for the radio buttons as a group.
 * @param $name
 *   The internal name used to refer to the buttons.
 * @param $value
 *   The currently selected radio button's key.
 * @param $options
 *   An associative array of buttons to display. The keys in this array are
 *   button values, while the values are the labels to display for each button.
 * @param $description
 *   Explanatory text to display after the form item.
 * @param $required
 *   Whether the user must select a radio button before submitting the form.
 * @param $attributes
 *   An associative array of HTML attributes to add to each button.
 * @return
 *   A themed HTML string representing the radio button set.
 */
function form_radios($title, $name, $value, $options, $description = NULL, $required = FALSE, $attributes = NULL) {
  if (count($options) > 0) {
    $choices = '';
    foreach ($options as $key => $choice) {
      $choices .= '<label class="option"><input type="radio" class="form-radio" name="edit['. $name .']" value="'. $key .'"'. ($key == $value ? ' checked="checked"' : ''). drupal_attributes($attributes). ' /> '. $choice .'</label><br />';
    }
    return theme('form_element', $title, $choices, $description, NULL, $required, _form_get_error($name));
  }
}

/**
 * Format an action button.
 *
 * @param $value
 *   Both the label for the button, and the value passed to the target page
 *   when this button is clicked.
 * @param $name
 *   The internal name used to refer to the button.
 * @param $type
 *   What type to pass to the HTML input tag.
 * @param $attributes
 *   An associative array of HTML attributes to add to the form item.
 * @return
 *   A themed HTML string representing the button.
 */
function form_button($value, $name = 'op', $type = 'submit', $attributes = NULL) {
  return '<input type="'. $type .'" class="form-'. $type .'" name="'. $name .'" value="'. check_form($value) .'" '. drupal_attributes($attributes) ." />\n";
}

/**
 * Format a form submit button.
 *
 * @param $value
 *   Both the label for the button, and the value passed to the target page
 *   when this button is clicked.
 * @param $name
 *   The internal name used to refer to the button.
 * @param $attributes
 *   An associative array of HTML attributes to add to the form item.
 * @return
 *   A themed HTML string representing the button.
 */
function form_submit($value, $name = 'op', $attributes = NULL) {
  return form_button($value, $name, 'submit', $attributes);
}

/**
 * Format an attribute string to insert in a tag.
 *
 * @param $attributes
 *   An associative array of HTML attributes.
 * @return
 *   An HTML string ready for insertion in a tag.
 */
function drupal_attributes($attributes = array()) {
  if ($attributes) {
    $t = array();
    foreach ($attributes as $key => $value) {
      $t[] = $key .'="'. $value .'"';
    }

    return ' '. implode($t, ' ');
  }
}

/**
 * Encode special characters in a string for display as HTML.
 *
 * Note that we'd like to use htmlspecialchars($input, $quotes, 'utf-8')
 * as outlined in the PHP manual, but we can't because there's a bug in
 * PHP < 4.3 that makes it mess up multibyte charsets if we specify the
 * charset. This will be changed later once we make PHP 4.3 a requirement.
 */
function drupal_specialchars($input, $quotes = ENT_NOQUOTES) {
  return htmlspecialchars($input, $quotes);
}

// and a little rippage from theme.inc

/**
 * Generate the themed representation of a Drupal object.
 *
 * All requests for themed functions must go through this function. It examines
 * the request and routes it to the appropriate theme function. If the current
 * theme does not implement the requested function, then the current theme
 * engine is checked. If neither the engine nor theme implement the requested
 * function, then the base theme function is called.
 *
 * For example, to retrieve the HTML that is output by theme_page($output), a
 * module should call theme('page', $output).
 *
 * @param $function
 *   The name of the theme function to call.
 * @param ...
 *   Additional arguments to pass along to the theme function.
 * @return
 *   An HTML string that generates the themed output.
 */
function theme() {
  global $theme;
  global $theme_engine;
  
  $args = func_get_args();
  $function = array_shift($args);

  if (($theme != '') && function_exists($theme .'_'. $function)) {
    // call theme function
    return call_user_func_array($theme .'_'. $function, $args);
  }
  elseif (($theme != '') && isset($theme_engine) && function_exists($theme_engine .'_'. $function)) {
    // call engine function
    return call_user_func_array($theme_engine .'_'. $function, $args);
  }
  elseif (function_exists('theme_'. $function)){
    // call Drupal function
    return call_user_func_array('theme_'. $function, $args);
  }
}

/**
 * Return a themed form element.
 *
 * @param $title the form element's title
 * @param $value the form element's data
 * @param $description the form element's description or explanation
 * @param $id the form element's ID used by the &lt;label&gt; tag
 * @param $required a boolean to indicate whether this is a required field or not
 * @param $error a string with an error message filed against this form element
 *
 * @return a string representing the form element
 */
function theme_form_element($title, $value, $description = NULL, $id = NULL, $required = FALSE, $error = FALSE) {

  $output  = "<div class=\"form-item\">\n";
  $required = $required ? theme('mark') : '';

  if ($title) {
    if ($id) {
      $output .= " <label for=\"$id\">$title:</label>$required<br />\n";
    }
    else {
      $output .= " <label>$title:</label>$required<br />\n";
    }
  }

  $output .= " $value\n";

  if ($description) {
    $output .= " <div class=\"description\">$description</div>\n";
  }

  $output .= "</div>\n";

  return $output;
}

/**
 * Return a themed error message.
 * REMOVE: this function is deprecated an no longer used in core.
 *
 * @param $message
 *   The error message to be themed.
 *
 * @return
 *   A string containing the error output.
 */
function theme_error($message) {
  return '<div class="error">'. $message .'</div>';
}

/**
 * Return a themed list of items.
 *
 * @param $items
 *   An array of items to be displayed in the list.
 * @param $title
 *   The title of the list.
 * @return
 *   A string containing the list output.
 */
function theme_item_list($items = array(), $title = NULL) {
  $output = '<div class="item-list">'."\n";
  if (isset($title)) {
    $output .= '<h3>'. $title .'</h3>'."\n";
  }

  if (isset($items)) {
    $output .= '<ul>'."\n";
    foreach ($items as $item) {
      $output .= '  <li>'. $item .'</li>'."\n";
    }
    $output .= '</ul>'."\n";
  }
  $output .= '</div>';
  return $output;
}

// looks like we need to rip stuff from bootstrap.inc too

/**
 * Since request_uri() is only available on Apache, we generate an
 * equivalent using other environment vars.
 */
function request_uri() {

  if (isset($_SERVER['REQUEST_URI'])) {
    $uri = $_SERVER['REQUEST_URI'];
  }
  else {
    if (isset($_SERVER['argv'])) {
      $uri = $_SERVER['PHP_SELF'] .'?'. $_SERVER['argv'][0];
    }
    else {
      $uri = $_SERVER['PHP_SELF'] .'?'. $_SERVER['QUERY_STRING'];
    }
  }
  
  return check_url($uri);
} 

/**
 * Prepare user input for use in a URI.
 *
 * We replace ( and ) with their entity equivalents to prevent XSS attacks.
 */
function check_url($uri) {
  $uri = htmlspecialchars($uri, ENT_QUOTES);

  $uri = strtr($uri, array('(' => '&040;', ')' => '&041;'));

  return $uri;
}

/**
 * Here.. have a function!
 */
function variable_get() {
  return FALSE;
}


// All the functions below this point are truly original as in that they did not
// originally come from drupal.  They may have been ripped of from somewhere else,
// though.  If so, the source is acknowledged accordingly.

function install_base_uri() {
  $url = $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'];
  return substr($url, 0, strrpos($url, '/'));
}

function install_config_path(){
  return 'sites/'.str_replace('/', '.',install_base_uri());
}

/**
 * Find out if settings.php has already been written by seeing if all
 * the variables defined in it still have the default values that
 * come with Drupal/CivicSpace "out of the box".
 *
 * @return
 *   A boolean.
 */
function install_conf_written_before() {
  global $db_url, $db_prefix, $base_url;
  // Check before for multi site installs
  if(file_exists(install_config_path().'/settings.php')){
    return TRUE;
  }
  // Check default install
  include_once('sites/default/settings.php');
  return (!(($db_url == '') &&
            ($db_prefix == '') &&
            ($base_url == '')));
}


function install_checklist($current_step = '') {
  // do something that generates the checklist html
  if ($current_step == 'Introduction' || $current_step == 'Installation already completed!') {
    return '';
  }
  $install_steps = install_steps();
  $install_steps_index = array_flip($install_steps);
  $index = isset($install_steps_index[$current_step]) ? $install_steps_index[$current_step] : 0;
  $list_html = "  <div id=\"secondary-content\">\n";
  $list_html .= "    <h2 class=\"hide\">Setup Process</h2>\n"; 
  $list_html .= "    <ol class=\"procedure-list\">\n";
  for ($step_number = 1; $step_number < count($install_steps); $step_number++) {
    if ($step_number < $index) {
      $list_html .= '      <li class="complete">'; 
    }
    elseif ($step_number > $index) {
      $list_html .= '      <li class="incomplete">';
    }
    else {
      $list_html .= '      <li class="incomplete active">';
    }
    $list_html .= '<span>'. $install_steps[$step_number]. '</span>';
    $list_html .= "</li>\n";
  }
  $list_html .= "    </ol>\n";
  $list_html .= "  </div>\n";
  return $list_html;
}


function install_steps() {
  return array('Introduction', 'Server check-up', 'Install', 'Database setup', 'Finishing up', 'Configure your site');
}


/**
 * This function was copied from the PHP.net website's documentation for the ini_get() function
 *
 * @return
 *   An integer.
 */
function return_bytes($val) {
   $val = trim($val);
   $last = $val{strlen($val)-1};
   switch($last) {
     case 'k':
     case 'K':
       return (int) $val * 1024;
       break;
     case 'm':
     case 'M':
       return (int) $val * 1048576;
       break;
     default:
       return $val;
   }
}


/**
 * This function returns a message about PHP's memory limit in regard to the installation process as
 * well as messages about other non-critical but important server-level prerequisites.
 *
 * @return
 *   A string
 *
 */
function install_warning_messages() {
  $messages = '';
  if (!function_exists('memory_get_usage')) {
    $messages .= _install_msg_successful('Your server has enough memory to run CivicSpace.');
  }
  else {
    $memory_limit = ini_get('memory_limit');
    if (return_bytes($memory_limit) < return_bytes('24M')) {
      $messages .= _install_msg_warning('Our memory check indicates that you currently have a memory limit of '. $memory_limit .' which is less than the recommended 24M.  You may proceed with the installation, but it is <em>strongly</em> recommended that you configure your PHP to provide you with at least 24M of memory.', NULL, 'http://www.civicspacelabs.org/installer_help/082/memory_check');
    }
    else {
      $messages .= _install_msg_successful('PHP has at least the recommended amount of memory for CivicSpace to run.');
    }
  }
  
  $base_uri = install_base_uri();
  $hostname = $_SERVER['HTTP_HOST'];
  
  if (strcasecmp($hostname, 'localhost') == 0 || substr($hostname, 0, 4) == '192.') {
    $messages .= _install_msg_notice('You appear to be installing CivicSpace on a private IP address or on \'localhost\'. If you would like your site to be publicly accessible, you need to restart this installer from a public domain or IP.', NULL, 'http://www.civicspacelabs.org/installer_help/082/url_warning');
  }

  if (ini_get('error_reporting') == E_ALL) {
    $messages .= _install_msg_warning('The installer has detected that your server\'s PHP is configured to report all levels of errors.  This can be a problem if you are running a production site.  It is recommended that you lower your level of error reporting to exclude PHP notices at the very least.', NULL, 'http://www.civicspacelabs.org/installer_help/082/error_reporting');
  } 
  
  return $messages;
}


function install_multisite_form($edit = array()){
  $form = '';
  // Parameters
  $edit['multisite_setup'] = isset($edit['multisite_setup']) ? $edit['multisite_setup'] : 0;
  $base_url = 'http://'. install_base_uri();
  $install_path = install_config_path().'/settings.php';
  
  $form .= form_radio('Single site set up', 'multisite_setup', 0, !$edit['multisite_setup'], 'Just keep this option checked if you want to set up a single site. The configuration file will be placed in <code>sites/default/settings.php</code>' );
  $form .= form_radio('Multiple site set up', 'multisite_setup', 1, $edit['multisite_setup'], 'Multi site set up. You will be able to set up more sites with this single CivicSpace install.  It is <strong>strongly</strong> recommended that you consult the <a href="http://civicspacelabs.org/installer_help/082" target="_blank">CS 0.8.2 installations guide</a>\'s page on <a href="http://civicspacelabs.org/installer_help/082/multiple_sites" target="_blank">setting up multiple sites</a>.');
  //$form .= form_textfield('Base URL', 'site_base_url', $base_url , 80, 80, );
  $form .= form_group('Parameters for multi-site set up',
     form_item('Base URL', $base_url, 'This will be the base URL for your CivicSpace installation')
     . form_item('Install path', $install_path, 'The configuration file for this site will be placed in <code>'. $install_path. '</code>' )
     );
  $form .= '<h4>CiviCRM Install Settings</h4>';
  // CiviCRM Settings.
    $form .= form_group('<b>CiviCRM Installation Settings</b>',
       form_checkbox('Enable CiviContribute', 'civicontribute', 1, $edit['civicontribute'], 'Use the CiviContribute component for collecting and managing online and offline contributions (<a href="http://objectledge.org/confluence/display/CRM/CiviContribute+Guide">documentation</a>)')
//     . form_checkbox('Enable CiviMail', 'civimail', 1, $edit['civimail'], 'Use the CiviMail high capacity broadcast mail component (<a href="http://objectledge.org/confluence/display/CRM/CiviMail+Guide">documentation</a>)')
     , 'These settings can be changed later by editing the civicrm.settings.php file.');
     
  /* Not really needed
  $form .= form_hidden('site_base_url', $base_url);
  $form .= form_hidden('site_install_path', $install_path);
  */
  // For flow control
  $form .= form_hidden('multisite_step',1);
  
  $form .= form(form_button('Setup database'));
  return form($form);
}


function install_database_form($edit = array()) {
  $edit['db_user'] = isset($edit['db_user']) ? $edit['db_user'] : '';
  $edit['db_pass'] = isset($edit['db_pass']) ? $edit['db_pass'] : '';
  $edit['db_host'] = isset($edit['db_host']) ? $edit['db_host'] : '';
  $edit['db_db'] = isset($edit['db_db']) ? $edit['db_db'] : '';
  $edit['db_prefix'] = isset($edit['db_prefix']) ? $edit['db_prefix'] : '';

  $edit['db_user_civicrm'] = isset($edit['db_user_civicrm']) ? $edit['db_user_civicrm'] : (isset($edit['db_user']) ? $edit['db_user'] : '');
  $edit['db_pass_civicrm'] = isset($edit['db_pass_civicrm']) ? $edit['db_pass_civicrm'] : (isset($edit['db_pass']) ? $edit['db_pass'] : '');
  $edit['db_host_civicrm'] = isset($edit['db_host_civicrm']) ? $edit['db_host_civicrm'] : (isset($edit['db_host']) ? $edit['db_host'] : '');
  $edit['db_db_civicrm'] = isset($edit['db_db_civicrm']) ? $edit['db_db_civicrm'] : (isset($edit['db_db']) ? $edit['db_db'] : '');

  $form .= form_textfield('User name', 'db_user', $edit['db_user'], 20, 64, '<span class="tip"><strong>Tip</strong>: Allowed characters include letters, digits, \'_\', and \'-\' with a maximum of 16 characters.</span>', NULL, TRUE);
  $form .= form_password('Password', 'db_pass', $edit['db_pass'] , 20, 64, '<span class="tip"><strong>Tip</strong>:  Allowed characters include <strong>letters</strong>, <strong>digits</strong>, and any of the following: -_!#$%^&*()+={}[]|&lt;&gt;;:?,.~</span>', NULL, TRUE);
  $form .= form_textfield('Host', 'db_host', $edit['db_host'] ? $edit['db_host'] : 'localhost', 20, 64, '<span class="tip"><strong>Tip</strong>: If your database is on the same machine as your CivicSpace installation, just enter "localhost". Leaving this item blank will default the value to "localhost".</span>', NULL, TRUE);
  $form .= form_textfield('Database name', 'db_db', $edit['db_db'], 20, 64, NULL, NULL, TRUE);
  $form .= form_textfield('Table prefix', 'db_prefix', $edit['db_prefix'], 20, 64, '<span class="tip"><strong>Tip</strong>:  If you are using a shared database account or only have one database account, you may wish to prefix your database tables to avoid a "naming collision." For example: "my_new_site_".</span>');
  $group_civicspace = "IMPORTANT: As a precaution, you may want to clear your browser's cookies before submitting this form.  In certain server/browser environments, you may get a session management error if you don't clear your cookies at this point.<br/>";
  $group_civicspace .= form_group('CivicSpace Database settings', $form, 'The settings in this box are for the CivicSpace database.');
  $form = form_textfield('User name', 'db_user_civicrm', $edit['db_user_civicrm'], 20, 64, '<span class="tip"><strong>Tip</strong>: Allowed characters include letters, digits, \'_\', and \'-\' with a maximum of 16 characters.</span>', NULL, TRUE);
  $form .= form_password('Password', 'db_pass_civicrm', $edit['db_pass_civicrm'] , 20, 64, '<span class="tip"><strong>Tip</strong>:  Allowed characters include <strong>letters</strong>, <strong>digits</strong>, and any of the following: -_!#$%^&*()+={}[]|&lt;&gt;;:?,.~</span>', NULL, TRUE);
  $form .= form_textfield('Host', 'db_host_civicrm', $edit['db_host_civicrm'] ? $edit['db_host_civicrm'] : '', 20, 64, '<span class="tip"><strong>Tip</strong>: If your database is on the same machine as your CivicSpace installation, just enter "localhost". Leaving this item blank will default the value to "localhost".</span>', NULL, TRUE);
  $form .= form_textfield('Database name', 'db_db_civicrm', $edit['db_db_civicrm'], 20, 64, NULL, NULL, TRUE);
  $group_civicrm = form_group('CiviCRM', $form, 'The settings in this box are for the CiviCRM database. If you want to use the same database for CivicSpace and CiviCRM, leave the form items in this box empty. Note that table prefixes will not be applied to the CiviCRM database. The installer will install the CiviCRM database for you if your database\'s version is recent enough. You will be notified of success or failure.');
  $form = form_checkbox('Install US zipcode database?', 'use_us_zipcodes', 1, isset($edit['use_us_zipcodes']) ? $edit['use_us_zipcodes'] : 1, '<span class="tip"><strong>Tip</strong>: <a href="javascript:alert(\'zipcode help!\');">Certain features</a> require the list of US zipcodes. Check this box to install.</span>');
  //$form = form_hidden('use_us_zipcodes', '1');
  //$form .= form_textfield('Got a Google Map key?', 'google_map', isset($edit['google_map']) ? $edit['google_map'] : '', 20, 64, '<span class="tip"><strong>Tip</strong>: Your Google .</span>');
  $form .= form_checkbox('Install CivicSpace Site Configuration Guide?', 'install_docs', 1, isset($edit['install_docs']) ? $edit['install_docs'] : 0, 'Check this box to install documentation for configuring your site.');
  $form .= form_hidden('db_type', 'mysql');
  $group_extra = form_group('Extras', $form, 'Some extra choices for the CivicSpace database.');
  $form = $group_civicspace . $group_civicrm . $group_extra;
  
   // Keep multisite settings
  $edit['multisite_setup'] = isset($edit['multisite_setup']) ? $edit['multisite_setup'] : 0;
  $form .= form_hidden('multisite_setup', $edit['multisite_setup']);
  
  // Keep CiviCRM settings
  $edit['civicontribute'] = isset($edit['civicontribute']) ? $edit['civicontribute'] : 0;
//  $edit['civimail'] = isset($edit['civimail']) ? $edit['civimail'] : 0;
  $form .= form_hidden('civicontribute', $edit['civicontribute']);
//  $form .= form_hidden('civimail', $edit['civimail']);

  if (isset($_POST['op']) && ($_POST['op'] == 'Retry table creation' || $_POST['op'] == 'Create tables')) {
    $form .= form_submit('Retry table creation');
//    $form .= form_submit('Cancel installation');
  }
  else {
    $form .= form_submit('Create tables');
  }
  return form($form);
}


function install_test_dbinfo(&$edit, &$error_status) {
  $edit['multisite_setup'] = isset($edit['multisite_setup']) ? $edit['multisite_setup'] : 0;

  $edit['db_host'] = isset($edit['db_host']) ? trim($edit['db_host']) : 'localhost';
  $edit['db_host'] = strlen($edit['db_host']) ? $edit['db_host'] : 'localhost';
  $edit['db_user'] = isset($edit['db_user']) ? trim($edit['db_user']) : '';
  $edit['db_pass'] = isset($edit['db_pass']) ? trim($edit['db_pass']) : '';
  $edit['db_db'] = isset($edit['db_db']) ? trim($edit['db_db']) : '';

  $edit['db_host_civicrm'] = strlen($edit['db_host_civicrm']) ? trim($edit['db_host_civicrm']) : $edit['db_host'];
  $edit['db_user_civicrm'] = strlen($edit['db_user_civicrm']) ? trim($edit['db_user_civicrm']) : $edit['db_user'];
  $edit['db_pass_civicrm'] = strlen($edit['db_pass_civicrm']) ? trim($edit['db_pass_civicrm']) : $edit['db_pass'];
  $edit['db_db_civicrm'] = strlen($edit['db_db_civicrm']) ? trim($edit['db_db_civicrm']) : $edit['db_db'];

  $edit['db_prefix'] = isset($edit['db_prefix']) ? trim($edit['db_prefix']) : '';
  
  if ($edit['db_prefix']) {
    $edit['db_prefix'] = _install_add_prefix_underscore($edit['db_prefix']);
  }
  
  $dummy_array = array();
  if ((!preg_match('/[A-Za-z0-9_-]+/', $edit['db_user'], $dummy_array)) && !(strlen($edit['db_pass']) > 16 || strlen($edit['db_pass']) < 1 )) {
    $error_status = 'invalid_user';
    return FALSE;
  }
  
  if ((!preg_match('/[A-Za-z0-9_-]+/', $edit['db_user_civicrm'], $dummy_array)) && !(strlen($edit['db_pass_civicrm']) > 16 || strlen($edit['db_pass_civicrm']) < 1 )) {
    $error_status = 'invalid_user_civicrm';
    return FALSE;
  }

  if ((!preg_match('/[A-Za-z0-9#@!$%^&*()+={[|\];<>?,.~:_-]*/', $edit['db_pass'], $dummy_array))) {
    $error_status = 'invalid_pass';
    return FALSE;
  }

  if ((!preg_match('/[A-Za-z0-9#@!$%^&*()+={[|\];<>?,.~:_-]*/', $edit['db_pass_civicrm'], $dummy_array))) {
    $error_status = 'invalid_pass_civicrm';
    return FALSE;
  }
  
  $connection = @mysql_connect($edit['db_host'], $edit['db_user'], $edit['db_pass']);
  if (!$connection) {
    $error_status = 'connection';
    return FALSE;
  }
  

  $db_exists = mysql_select_db($edit['db_db'], $connection);
  if (!$db_exists) {
    $error_status = 'database_name';
    return FALSE;    
  }

  $collision_check = _install_tablenames_collide($connection, $edit);
  if ($collision_check) {
    $error_status = $collision_check;
    return FALSE;
  }

  $connection_civicrm = @mysql_connect($edit['db_host_civicrm'], $edit['db_user_civicrm'], $edit['db_pass_civicrm']);
  if (!$connection_civicrm) {
    $error_status = 'connection_civicrm';
    return FALSE;
  }

  $db_exists_civicrm = mysql_select_db($edit['db_db_civicrm'], $connection_civicrm);
  if (!$db_exists_civicrm) {
    $error_status = 'database_name_civicrm';
    return FALSE;    
  }

  $collision_check = _install_tablenames_collide($connection_civicrm, $edit, 'CiviCRM');
  if ($collision_check) {
    $error_status = $collision_check;
    return FALSE;
  }

  $db_version_check = mysql_fetch_object(mysql_query('SELECT VERSION() AS version', $connection_civicrm));
  if ($last = strrpos($db_version_check->version, '_')) {
    $db_version_check->version = substr($db_version_check->version, 0, $last);
  }
  if ($last = strrpos($db_version_check->version, '-')) {
    $db_version_check->version = substr($db_version_check->version, 0, $last);
  }
  $edit['mysql_version'] = explode('.', $db_version_check->version);
  $_SESSION['mysql_version'] = $edit['mysql_version'];
  if ($edit['mysql_version'][0] < 4) {
    $error_status = 'database_version_civicrm';
    return FALSE;
  }

  return TRUE;
}


function _install_add_prefix_underscore($prefix) {
  if ($prefix) {
    if (substr(strrev($prefix), 0, 1) == '_') {
      return $prefix;
    }
    else {
      return $prefix . '_';
    }
  }
}


/**
 * Queries database to see if table name collision occurs given DB info submitted in $edit parameter.
 *
 * Returns string:
 *   'failure' if query for existing tables in the database $edit['db_db'] does not go through for some reason
 *        (e.g., lack of permissions for the account to execute a "show tables" query).
 *   '' if no collision occurs.
 *   'collision' if collision occurs.
 */
function _install_tablenames_collide($connection, $edit, $type = 'Drupal') {

  if ($type == 'Drupal') {
    $table_names = array('access', 'accesslog', 'aggregator_category', 'aggregator_category_feed', 'aggregator_category_item', 'aggregator_feed', 'aggregator_item', 'authmap', 'blocks', 'book', 'boxes', 'buddylist', 'cache', 'comments', 'contact', 'contact_data', 'contact_search', 'contact_sources', 'directory', 'event', 'event_field_data', 'event_item', 'files', 'filter_formats', 'filters', 'flexinode_data', 'flexinode_field', 'flexinode_type', 'form_fields', 'forms', 'forum', 'history', 'htmlarea', 'image', 'listhandler', 'location_node', 'location_user', 'locales_meta', 'locales_source', 'locales_target', 'mailhandler', 'menu', 'moderation_filters', 'moderation_roles', 'moderation_votes', 'node', 'node_access', 'node_comment_statistics', 'node_counter', 'node_import_mappings', 'notify', 'page', 'permission', 'phplist_config', 'phplist_contact_searches', 'phplist_list', 'phplist_listmessage', 'phplist_listuser', 'phplist_message', 'phplist_rssitem', 'phplist_sendprocess', 'phplist_user_attribute', 'phplist_user_rss', 'phplist_user_user', 'phplist_usermessage', 'poll', 'poll_choices', 'privatemsg', 'privatemsg_archive', 'privatemsg_folder', 'profile_fields', 'profile_values', 'role', 'rsvp', 'rsvp_event', 'rsvp_to_user', 'rsvp_user_prefs', 'search_index', 'sequences', 'sessions', 'story_item', 'survey', 'survey_fields', 'survey_responses', 'system', 'term_data', 'term_hierarchy', 'term_node', 'term_relation', 'term_synonym', 'trackback_received', 'trackback_sent', 'url_alias', 'users', 'users_roles', 'variable', 'vocabulary', 'volunteer', 'volunteer_contact_event', 'watchdog', 'zipcodes');
    if ($edit['db_prefix']) {
      foreach ($table_names as $key => $value) {
        $table_names[$key] = $edit['db_prefix'] . $value;
      }
    }
    $existing_tables = array();
    $result = mysql_query('SHOW TABLES FROM '. trim($edit['db_db']), $connection);
    if (!(is_resource($result) && get_resource_type($result) == 'mysql result')) {
      return 'failure';
    }
  
    while($row = mysql_fetch_array($result)) {
      $existing_tables[] = $row[0];
    }
    
    if (count(array_intersect($table_names, $existing_tables))) {
      return 'collision';
    }
    else {
      return '';
    }
  }
  else if ($type == 'CiviCRM') {
    $table_names = array('civicrm_mailing_event_unsubscribe', 'civicrm_mailing_event_trackable_url_open', 'civicrm_mailing_event_reply', 'civicrm_mailing_event_opened', 'civicrm_mailing_event_forward', 'civicrm_mailing_event_delivered', 'civicrm_mailing_event_bounce', 'civicrm_mailing_event_queue', 'civicrm_group_contact', 'civicrm_im', 'civicrm_email', 'civicrm_address', 'civicrm_activity_history', 'civicrm_activity', 'civicrm_mailing_event_confirm', 'civicrm_mailing_event_subscribe', 'civicrm_relationship', 'civicrm_subscription_history', 'civicrm_group', 'civicrm_uf_match', 'civicrm_phonecall', 'civicrm_phone', 'civicrm_note', 'civicrm_meeting', 'civicrm_location', 'civicrm_import_mapping_field', 'civicrm_entity_tag', 'civicrm_email_history', 'civicrm_custom_value', 'civicrm_custom_option', 'civicrm_custom_field', 'civicrm_custom_group', 'civicrm_county', 'civicrm_activity_type', 'civicrm_donation_page', 'civicrm_mailing_bounce_pattern', 'civicrm_mailing_bounce_type', 'civicrm_mailing_job', 'civicrm_mailing_trackable_url', 'civicrm_mailing_group', 'civicrm_mailing', 'civicrm_mailing_component', 'civicrm_saved_search', 'civicrm_relationship_type', 'civicrm_organization', 'civicrm_individual', 'civicrm_household', 'civicrm_contact', 'civicrm_validation', 'civicrm_uf_field', 'civicrm_uf_group', 'civicrm_tag', 'civicrm_state_province', 'civicrm_mobile_provider', 'civicrm_location_type', 'civicrm_import_mapping', 'civicrm_im_provider', 'civicrm_geo_coord', 'civicrm_domain', 'civicrm_country');
    $existing_tables = array();
    $result = mysql_query('SHOW TABLES FROM '. trim($edit['db_db_civicrm']), $connection);
    if (!(is_resource($result) && get_resource_type($result) == 'mysql result')) {
      return 'failure_civicrm';
    }
    while($row = mysql_fetch_array($result)) {
      $existing_tables[] = $row[0];
    }
    
    if (count(array_intersect($table_names, $existing_tables))) {
      return 'collision_civicrm';
    }
    else {
      return '';
    }
  }
}

function _install_help_link($link) {
  return '<a href="'. $link .'" target="_blank">More help</a>';
}

function _install_msg_successful($message, $title = 'Success!') {
  $output  = '            <div class="message message-success">'."\n";
  $output .= '              <p>'."\n";
  $output .= '                 <strong>'. $title .'</strong>'."\n";
  $output .= '                   '. $message ."\n";
  $output .= '              </p>'."\n";
  $output .= '            </div>'."\n";
  return $output;
}


function _install_msg_failed($message, $title = 'Whoops!', $link = NULL) {
  if (!$title) {
    $title = 'Whoops!'; 
  }
  $output  = '            <div class="message message-error">'."\n";
  $output .= '              <p>'."\n";
  $output .= '                 <strong>'. $title .'</strong>'."\n";
  $output .= '                 '. $message ."\n";
  
  if ($link) {
    $output .= '                 '. _install_help_link($link) ."\n";
  }
  
  $output .= '              </p>'."\n";
  $output .= '            </div>'."\n";
  return $output;
}


function _install_msg_warning($message, $title = 'Warning', $link = NULL) {
  if (!$title) {
    $title = 'Warning';
  }
  $output  = '            <div class="message message-warning">'."\n";
  $output .= '              <p>'."\n";
  $output .= '                 <strong>'. $title .':</strong> '."\n";
  $output .= '                 '. $message ."\n";
  
  if ($link) {
    $output .= '                 '. _install_help_link($link) ."\n";
  }
  
  $output .= '              </p>'."\n";
  $output .= '            </div>'."\n";
  return $output;
}


function _install_msg_notice($message, $title = 'Notice', $link = NULL) {
  if (!$title) {
    $title = 'Notice';
  }
  $output  = '            <div class="message message-notice">'."\n";
  $output .= '              <p>'."\n";
  $output .= '                 <strong>'. $title .':</strong> '."\n";
  $output .= '                 '. $message ."\n";
  
  if ($link) {
    $output .= '                 '. _install_help_link($link) ."\n";
  }
  
  $output .= '              </p>'."\n";
  $output .= '            </div>'."\n";
  return $output;
}


function _install_msg_important($message, $title = 'Important', $link = NULL) {
  if (!$title) {
    $title = 'Important';
  }
  $output  = '            <div class="message message-important">'."\n";
  $output .= '              <p>'."\n";
  $output .= '                 <strong>'. $title .':</strong> '."\n";
  $output .= '                 '. $message ."\n";
  
  if ($link) {
    $output .= '                 '. _install_help_link($link) ."\n";
  }
  
  $output .= '              </p>'."\n";
  $output .= '            </div>'."\n";
  return $output;
}


function install_write_conf($edit, $type = 'Drupal') {
  if ($type == 'Drupal') {
    $configfile = 'settings.php';
  }
  else if ($type == 'CiviCRM') {
    $configfile = 'civicrm.settings.php';
  }
  // Check if multisite setup
  if(isset($edit['multisite_setup']) && $edit['multisite_setup']) {
    $path = install_config_path();
    if(!file_exists($path)){
      mkdir($path, 0777);
    }
    if(!file_exists($path.'/'.$configfile)){
      copy('sites/default/'.$configfile, $path.'/'.$configfile);
    }
  } else {
    $path = 'sites/default/';
  }

  $fp = fopen($path.'/'.$configfile, 'w');
  fwrite($fp, _install_create_conf_file($edit, $type));
  fclose($fp);
}

function _install_db_query($edit, $dump) {

  if(!preg_match('/^civicrm_/', $_SESSION['install_dump_files'][$_SESSION['current_file_index']] ) &&
     !_install_looks_like_civicrm_query($dump)) {
    $insert_into_sequences = 'INSERT INTO '. $edit['db_prefix'] .'sequences';
    $replace_into_sequences = 'REPLACE INTO '. $edit['db_prefix'] .'sequences';

    foreach (preg_split('/;\n/', preg_replace('/^--[^\n]*\n/', '', preg_replace('/(CREATE TABLE|CREATE INDEX|INSERT INTO|REPLACE INTO|DELETE FROM|ALTER TABLE|LOCK TABLES|DROP TABLE IF EXISTS) (\w+)/', '\1 '. $edit['db_prefix'] .'\2', $dump))) as $query) {
      if ($query = trim($query)) {
        // For insert statements into the {sequences} table, the string value being inserted also itself needs to be prefixed.
        // That's what the preg_replace shown directly below does.  Same goes for replaces.
        if ($edit['db_prefix'] && substr_count($query, $insert_into_sequences)) {
          $query = preg_replace("/INSERT INTO ([a-zA-Z0-9_]*)sequences VALUES \('([a-zA-Z_]*)'(.*)/", 'INSERT INTO \1sequences VALUES (\'\1\2\''.'\3', $query);
        }
        
        if ($edit['db_prefix'] && substr_count($query, $replace_into_sequences)) {
          $query = preg_replace("/REPLACE INTO ([a-zA-Z0-9_]*)sequences VALUES \('([a-zA-Z_]*)'(.*)/", 'REPLACE INTO \1sequences VALUES (\'\1\2\''.'\3', $query);
        }
        db_set_active();
        _db_query($query);
      }
    }
  }
  else {
    db_set_active('civicrm');
    foreach (preg_split('/;\n/', preg_replace('/^--[^\n]*\n/', '', preg_replace('/(CREATE TABLE|CREATE INDEX|INSERT INTO|REPLACE INTO|DELETE FROM) (\w+)/', '\1 \2', $dump))) as $query) {
      if ($query = trim($query)) {
        _db_query($query);
      }
    }
    db_set_active();
  }
}

function _install_dump_and_serve(&$edit) {
  if (!isset($edit)) {
    $edit = array();
  }
  $query_counts = array('civicspace' => 287);
  if (count($edit)) {
    $_SESSION['multisite_setup'] = $edit['multisite_setup'];
    $_SESSION['civicontribute'] = $edit['civicontribute'];
//    $_SESSION['civimail'] = $edit['civimail'];
    $_SESSION['db_user'] = $edit['db_user'];
    $_SESSION['db_pass'] = $edit['db_pass'];
    $_SESSION['db_host'] = $edit['db_host'];
    $_SESSION['db_db'] = $edit['db_db'];
    $_SESSION['db_user_civicrm'] = strlen($edit['db_user_civicrm']) ? $edit['db_user_civicrm'] : $edit['db_user'];
    $_SESSION['db_pass_civicrm'] = strlen($edit['db_pass_civicrm']) ? $edit['db_pass_civicrm'] : $edit['db_pass'];
    $_SESSION['db_host_civicrm'] = strlen($edit['db_host_civicrm']) ? $edit['db_host_civicrm'] : $edit['db_host'];
    $_SESSION['db_db_civicrm'] = strlen($edit['db_db_civicrm']) ? $edit['db_db_civicrm'] : $edit['db_db'];
    $_SESSION['db_type'] = $edit['db_type'];
    $_SESSION['db_prefix'] = $edit['db_prefix'];
    $_SESSION['install_dump_files'] = array('civicspace');

    if (isset($_SESSION['mysql_version']) && $_SESSION['mysql_version'][0] > 3) {
      if ($_SESSION['mysql_version'][1] == 0 && !in_array('civicrm_40', $_SESSION['install_dump_files'])) {
        $_SESSION['install_dump_files'][] = 'civicrm_40';
        $_SESSION['mysql_version_confirmed'] = '4.0';
        $query_counts = array_merge($query_counts, array('civicrm_40' => 148));
      }
      else if ($_SESSION['mysql_version'][1] > 0 && !in_array('civicrm_41', $_SESSION['install_dump_files'])) {
        $_SESSION['install_dump_files'][] = 'civicrm_41';
        $_SESSION['mysql_version_confirmed'] = '4.1';
        $query_counts = array_merge($query_counts, array('civicrm_41' => 148));
      }
      if (!in_array('civicrm_data', $_SESSION['install_dump_files'])) {
        $_SESSION['install_dump_files'][] = 'civicrm_data';
        $query_counts = array_merge($query_counts, array('civicrm_data' => 317));
      }
    }
    $_SESSION['use_us_zipcodes'] = $edit['use_us_zipcodes'];
    $_SESSION['google_map'] = $edit['google_map'];
    $_SESSION['install_docs'] = $edit['install_docs'];
    if ($edit['use_us_zipcodes'] && !in_array('zipcodes', $_SESSION['install_dump_files'])) {
      $query_counts = array_merge($query_counts, array('zipcodes' => 43187));
      $_SESSION['install_dump_files'][] = 'zipcodes';
    }
    if ($edit['install_docs'] && !in_array('documentation', $_SESSION['install_dump_files'])) {
      $query_counts = array_merge($query_counts, array('documentation' => 60));
      $_SESSION['install_dump_files'][] = 'documentation';
    }
  }
  else {
    $edit['multisite_setup'] = $_SESSION['multisite_setup'];
    $edit['civicontribute'] = $_SESSION['civicontribute'];
//    $edit['civicmail'] = $_SESSION['civimail'];
    $edit['db_user'] = $_SESSION['db_user'];
    $edit['db_pass'] = $_SESSION['db_pass'];
    $edit['db_host'] = $_SESSION['db_host'];
    $edit['db_db'] = $_SESSION['db_db'];
    $edit['db_user_civicrm'] = strlen($_SESSION['db_user_civicrm']) ? $_SESSION['db_user_civicrm'] : $_SESSION['db_user'];
    $edit['db_pass_civicrm'] = strlen($_SESSION['db_pass_civicrm']) ? $_SESSION['db_pass_civicrm'] : $_SESSION['db_pass'];
    $edit['db_host_civicrm'] = strlen($_SESSION['db_host_civicrm']) ? $_SESSION['db_host_civicrm'] : $_SESSION['db_host'];
    $edit['db_db_civicrm'] = strlen($_SESSION['db_db_civicrm']) ? $_SESSION['db_db_civicrm'] : $_SESSION['db_db'];
    $edit['db_type'] = $_SESSION['db_type'];
    $edit['db_prefix'] = $_SESSION['db_prefix'];
    $edit['use_us_zipcodes'] = $_SESSION['use_us_zipcodes'];
    $edit['google_map'] = $_SESSION['google_map'];
    $edit['install_docs'] = $_SESSION['install_docs'];
    $edit['mysql_version_confirmed'] = $_SESSION['mysql_version_confirmed'];
  }
  
  include_once('includes/database.inc');
  
  if (!isset($_SESSION['total_query_count'])) {
    $_SESSION['total_query_count'] = 0;
    foreach($query_counts as $count) {
      $_SESSION['total_query_count'] += $count;
    }
  }
  
  // CYCLE PATTERN: (1) DUMP QUERIES, (2) SERVE PAGE
  // STEP #1: Set up query count information
  // ----------------------------------------------------------------------------------------------------------------
  
  $_SESSION['finished_query_count'] = isset($_SESSION['finished_query_count']) ? $_SESSION['finished_query_count'] : 0;
  
  // This is a good place to check if we've executed all of our queries.  If we have, then we just serve the final
  // page of the installation wizard
  if ($_SESSION['finished_query_count'] >= $_SESSION['total_query_count']) {
    foreach ($_SESSION as $key => $value) {
      unset($_SESSION[$key]);
    }
    
    // Some special closing queries
    _install_closing_queries($edit);
    
    install_write_conf($edit, 'Drupal');
    install_write_conf($edit, 'CiviCRM');
    print install_step_page('Finishing up');
    exit();
  }
  
  // What is one-tenth of the total number of queries being dumped?
  $one_tenth = round($_SESSION['total_query_count'] / 10);
  
  $_SESSION['current_tenth'] = isset($_SESSION['current_tenth']) ? $_SESSION['current_tenth'] : 1;

  // Need to know the total number of queries that need to be executed for
  // completion of the current tenth of queries
  $current_limit = $_SESSION['current_tenth'] * $one_tenth;
  
  // Rounded (tenth * current_tenth) does not give $_SESSION['total_query_count']
  // This number will be off by a few, force the limit to be the total_query_count,
  // when we get to the last tenth.
  if ($_SESSION['current_tenth'] == 10) {
    $current_limit = $_SESSION['total_query_count'];
  }
  // -------------------------------------------------------------------------------------------------------------------
 
  // STEP #2: Set up marker for which file needs to be dumped; create handles if necessary
  // Serve final page if there are no more files that need to be dumped
  // -------------------------------------------------------------------------------------------------------------------    
  if (!isset($_SESSION['current_file_handle_offset'])) {
    $_SESSION['current_file_index'] = isset($_SESSION['current_file_index']) ? $_SESSION['current_file_index'] + 1 : 0;
    if ($_SESSION['current_file_index'] >= count($_SESSION['install_dump_files'])) {
      foreach ($_SESSION as $key => $value) {
        unset($_SESSION[$key]);
      }
      
      // Some special post-install queries
      _install_closing_queries($edit);
      
      install_write_conf($edit, 'Drupal');
      install_write_conf($edit, 'CiviCRM');
      print install_step_page('Finishing up');
      exit();
    }
    else {
      $current_file_handle = fopen('database/'. $_SESSION['install_dump_files'][$_SESSION['current_file_index']] .'.'. $_SESSION['db_type'], 'r');
    }
  }
  else {
    $current_file_handle = fopen('database/'. $_SESSION['install_dump_files'][$_SESSION['current_file_index']] .'.'. $_SESSION['db_type'], 'r');
    fseek($current_file_handle, $_SESSION['current_file_handle_offset']);
  }
  
  // Execute the queries here.  Stop when the end of a file is reached or when the current number of tenths has been completed.
  while ($_SESSION['finished_query_count'] < $current_limit) {
    if ($query = _install_get_next_query($current_file_handle)) {
      _install_db_query($edit, $query);
      $_SESSION['finished_query_count'] += 1;
    }
    else {
      break;
    }
  }
 
  // $query == NULL or EOF or something that equivalent to FALSE if there were no more queries in the current file
  // In this case, we close the file and unset the $_SESSION variable that stores it so this function knows to open
  // the next one when the client-browser is redirected back to this function
  if (feof($current_file_handle)) {
    unset($_SESSION['current_file_handle_offset']);
    $_SESSION['continue_dump'] = TRUE;
  }
  else {
    $_SESSION['current_file_handle_offset'] = ftell($current_file_handle);
  }
  
  if ($_SESSION['finished_query_count'] >= $current_limit) {
    $_SESSION['current_tenth'] += 1;
    $_SESSION['continue_dump'] = TRUE;
  }
  
 
  //header('Location: http://'. install_base_uri() . '/install.php?op=continue_dump');
  print _install_dump_interstitial_page(round(100 * $_SESSION['finished_query_count'] / $_SESSION['total_query_count']));
  exit;

}


function _install_get_next_query($handle) {
  $query = '';
  if (!$handle) {
    return NULL;
  }
  while ($nextline = fgets($handle)) {
    if (!(substr(trim($nextline),0,2) == '--' || trim($nextline) == '')) {
      $query .= (strlen($query) ? "\n" : '') . $nextline;
      if (substr(trim(strrev($query)), 0, 1) == ';') {
        return $query;
      }
    }
  }
  
  return $query;
}


/**
 * A page to serve when dumping files.
 *
 * Not sure if I need it yet.
 */
function _install_dump_interstitial_page($percentage) {
  $output = '';
  $output .= install_page_header('Setting up database...', $percentage);
  $output .= install_checklist('Database setup');
  $output .= install_step_main_content('Setting up database...', $percentage);
  $output .= install_page_footer();
  print $output;
}


function _install_create_conf_file($edit, $type = 'Drupal') {

  if ($type == 'Drupal') {
    $contents  = '<?php'."\n";
    $contents .= "\n";
    $contents .= '/**'."\n";
    $contents .= ' * @file'."\n";
    $contents .= ' * This file stores basic but essential Drupal site-specific settings. '."\n";
    $contents .= ' */'."\n";
    $contents .= "\n";
    $contents .= '#'."\n";
    $contents .= '# Instructions:'."\n";
    $contents .= '#'."\n";
    $contents .= '#   You will need to set the values of two mandatory variables in this file.'."\n";
    $contents .= '#   The first concerns your database connection and the second tells Drupal'."\n";
    $contents .= '#   where you website will be located. Optionally, you can specify additional'."\n";
    $contents .= '#   PHP settings at the end of this file.'."\n";
    $contents .= '#'."\n";
    $contents .= "\n";
    $contents .= '#'."\n";
    $contents .= '# 1. Set your database connection and optional prefix.'."\n";
    $contents .= '#'."\n";
    $contents .= '#   The database connection string tells Drupal how to connect to your database,'."\n";
    $contents .= '#   where it\'s located and what its name is.'."\n";
    $contents .= '#'."\n";
    $contents .= '#   Some examples are:'."\n";
    $contents .= '#     $db_url = \'mysql://user:password@hostname/database\';'."\n";
    $contents .= '#     $db_url = \'pgsql://user:password@hostname/database\'; '."\n";
    $contents .= '#'."\n";
    $contents .= '#   You should be able to get this information from your webhost or systems'."\n";
    $contents .= '#   administrator. Drupal cannot retreive or set this information for you.'."\n";
    $contents .= '#'."\n";
    $contents .= '#   Advanced users: To specify multiple connections for your site (i.e. for '."\n";
    $contents .= '#   complex custom modules) you can also specify an associative array of $db_url '."\n";
    $contents .= '#   variables with the \'default\' element used until otherwise requested.'."\n";
    $contents .= '#'."\n";
    $contents .= '#   To set the value of the variable, please fill in a value:'."\n";
    $contents .= "\$db_url['default'] = '". $edit['db_type'] .'://'. $edit['db_user'] .':'. $edit['db_pass'] .'@'. $edit['db_host'] .'/'. $edit['db_db'] .'\';'."\n";
    $contents .= "\$db_url['civicrm'] = '". $edit['db_type'] .'://'. $edit['db_user_civicrm'] .':'. $edit['db_pass_civicrm'] .'@'. $edit['db_host_civicrm'] .'/'. $edit['db_db_civicrm'] .'\';'."\n";
    $contents .= "\n";
    $contents .= '#   Optional: If you would like to prefix the database tables used for this '."\n";
    $contents .= '#   Drupal site, you may specify an alphanumeric prefix string. This setting'."\n";
    $contents .= '#   can be helpful if you are working with only one database.'."\n";
    $contents .= '#'."\n";
    $contents .= '#   Some examples could be:'."\n";
    $contents .= '#     $db_prefix = \'demosite_\';'."\n";
    $contents .= '#     $db_prefix = \'userblog_\';'."\n";
    $contents .= '#'."\n";
    $contents .= '#   If you do not want to prefix your tables, set the value to an empty string "".'."\n";
    $contents .= "# Note: the CiviCRM part of the database is not affected by the db prefix.\n";
    $contents .= '$db_prefix = \''. $edit['db_prefix'] .'\';'."\n";
    $contents .= "\n"; 
    $contents .= '#'."\n";
    $contents .= '#  2. Set your site address:'."\n";
    $contents .= '#'."\n";
    $contents .= '#   The $base_url tells Drupal where to look for your website files. The value'."\n";
    $contents .= '#   should be a standard URL without a slash ("/") on the end. '."\n";
    $contents .= '#'."\n";
    $contents .= '#   Some examples are:'."\n";
    $contents .= '#   $base_url = \'http://www.hostname.org\';'."\n";
    $contents .= '#   $base_url = \'http://www.hostname.com/drupalsite\';'."\n";
    $contents .= '$base_url = \'http://'. install_base_uri() .'\';'."\n";
    $contents .= "\n";
    $contents .= '#'."\n";
    $contents .= '# 3. Advanced PHP settings:'."\n";
    $contents .= '#'."\n";
    $contents .= '#   Normally, you will not need to change your PHP settings. However, if you would '."\n";
    $contents .= '#   like to make changes, take a look at the .htaccesss file in Drupal\'s root '."\n";
    $contents .= '#   directory for an idea of the settings to override. If you get unexpected '."\n";
    $contents .= '#   warnings or errors, double-check your PHP settings.'."\n";
    $contents .= "\n";
    $contents .= '#   If required, you may set an alternate path to include your PEAR directory.'."\n";
    $contents .= '#   Simply remove the comment slashes ("//") and replace ".:/path/to/pear" with'."\n";
    $contents .= '#   the location of your PEAR directory.'."\n";
    $contents .= '// ini_set("include_path", ".:/path/to/pear");'."\n";
    $contents .= "\n";
    $contents .= "\n";
    $contents .= '?>'."\n";
  }
  else if ($type == 'CiviCRM') {
      $contents .= "<?php\n";
      $contents .= "/**\n";
      $contents .= " * CiviCRM configuration file.\n";
      $contents .= " */\n";
      $contents .= "\n";
      $contents .= "/**\n";
      $contents .= " * Content Management System (CMS) Host:\n";
      $contents .= " *\n";
      $contents .= " * CiviCRM can be hosted in either Drupal or Mambo. Retain the default settings\n";
      $contents .= " * for Drupal.\n";
      $contents .= " * \n";
      $contents .= " * Settings for Mambo:\n";
      $contents .= " *      define( 'CIVICRM_UF'       , 'Mambo' );\n";
      $contents .= " *      define( 'CIVICRM_UF_URLVAR', 'task'  );\n";
      $contents .= " */\n";
      $contents .= "define( 'CIVICRM_UF'               , 'Drupal' );\n";
      $contents .= "define( 'CIVICRM_UF_URLVAR'        , 'q'  );\n";
      $contents .= "\n";
      $contents .= "/**\n";
      $contents .= " * Enable CiviCRM Components:\n";
      $contents .= " *\n";
      $contents .= " * You can choose to enable or hide add-on components which provide additional functionality\n";
      $contents .= " * for your CiviCRM site by listing the component names (separated by commas) below.\n";
      $contents .= " *\n";
      $contents .= " * EXAMPLE: enable the CiviContribute component for collecting and managing online and offline\n";
      $contents .= " * contributions, as well as the CiviMail high capacity broadcast mail component:\n";
      $contents .= " *      define( 'ENABLE_COMPONENTS', 'CiviContribute, CiviMail' );\n";
      $contents .= " *\n";
      $contents .= "*/\n";

      // Enable extra componets?
      if ($edit['civicontribute']) {
        $componets = "CiviContribute";
      }
//      if ($edit['civicontribute'] && $edit['civimail']) {
//        $componets .= ", ";
//      }
//      if ($edit['civimail']) {
//        $componets .= "CiviMail";
//      }


      $contents .= "define( 'ENABLE_COMPONENTS', \"$componets\" );\n";
      $contents .= "\n";
      $contents .= "/**\n";
      $contents .= " *\n";
      $contents .= " * Update the CIVICRM_UF_DSN setting to match your Drupal or Mambo database username, server and DB name.\n";
      $contents .= " * Database URL format:\n";
      $contents .= " *      define( 'CIVICRM_UF_DSN', 'mysql://drupal_db_username:drupal_db_password@db_server/drupal_database?new_link=true');\n";
      $contents .= " */\n";
      $contents .= "define( 'CIVICRM_UF_DSN', '". $edit['db_type'] .'://'. $edit['db_user'] .':'. $edit['db_pass'] .'@'. $edit['db_host'] .'/'. $edit['db_db'] ."?new_link=true' );\n";
      $contents .= "\n";
      $contents .= "/** \n";
      $contents .= " *\n";
      $contents .= " * Update the CIVICRM_UF_USERSTABLENAME if needed to match the name of the table\n";
      $contents .= " * where the CMS user data is stored. For default Drupal installs, this is 'users'.\n";
      $contents .= " * If you are using table-prefixing for the users table, you must enter the tablename\n";
      $contents .= " * with the prefix.\n";
      $contents .= " */ \n";
      $contents .= "define( 'CIVICRM_UF_USERSTABLENAME', '". $edit['db_prefix'] ."users' );\n";
      $contents .= "\n";
      $contents .= "/**\n";
      $contents .= " * File system paths for this install:\n";
      $contents .= " *\n";
      $contents .= " * \$civicrm_root is the file system path on your server where the civicrm\n";
      $contents .= " * code is installed.\n";
      $contents .= " *\n";
      $contents .= " * CIVICRM_TEMPLATE_COMPILEDIR is the file system path where compiled templates are stored.\n";
      $contents .= " *\n";
      $contents .= " * CIVICRM_UPLOADDIR is the file system path to which CiviCRM files are uploaded.\n";
      $contents .= " *\n";
      $contents .= " * EXAMPLE - CivicSpace / Drupal:\n";
      $contents .= " * If the path to the CivicSpace or Drupal home directory is /var/www/htdocs/civicspace\n";
      $contents .= " * the \$civicrm_root setting would be:\n";
      $contents .= " *      \$civicrm_root = '/var/www/htdocs/civicspace/modules/civicrm';\n";
      $contents .= " *\n";
      $contents .= " * the CIVICRM_TEMPLATE_COMPILEDIR would be:\n";
      $contents .= " *      define( 'CIVICRM_TEMPLATE_COMPILEDIR', '/var/www/htdocs/civicspace/files/civicrm/templates_c' );\n";
      $contents .= " *\n";
      $contents .= " * and the CIVICRM_UPLOADDIR would be:\n";
      $contents .= " *      define( 'CIVICRM_UPLOADDIR', '/var/www/htdocs/civicspace/files/civicrm/upload' );\n";
      $contents .= " *\n";
      $contents .= " * EXAMPLE - Mambo:\n";
      $contents .= " * If the path to the Mambo home directory is /var/www/htdocs/mambo\n";
      $contents .= " * the \$civicrm_root setting would be:\n";
      $contents .= " *      \$civicrm_root = '/var/www/htdocs/mambo/administrator/components/com_civicrm/civicrm';\n";
      $contents .= " *\n";
      $contents .= " * the CIVICRM_TEMPLATE_COMPILEDIR would be:\n";
      $contents .= " *      define( 'CIVICRM_TEMPLATE_COMPILEDIR', '/var/www/htdocs/mambo/media/civicrm/templates_c' );\n";
      $contents .= " *\n";
      $contents .= " * and the CIVICRM_UPLOADDIR would be:\n";
      $contents .= " *      define( 'CIVICRM_UPLOADDIR', '/var/www/htdocs/mambo/media/civicrm/upload' );\n";
      $contents .= " *  \n";
      $contents .= " * Please make sure that the COMPILERDIR and UPLOADDIR are created and the\n";
      $contents .= " * web server user has write access to that directory\n";
      $contents .= " *\n";
      $contents .= " */\n";
      $contents .= "global \$civicrm_root;\n";
      $contents .= "\$civicrm_root = './modules/civicrm';\n";
      $contents .= "define( 'CIVICRM_TEMPLATE_COMPILEDIR', './files/civicrm/templates_c' );\n";
      $contents .= "define( 'CIVICRM_UPLOADDIR'          , './files/civicrm/upload/'  );\n";
      $contents .= "\n";
      $contents .= "/**\n";
      $contents .= " * Site URLs:\n";
      $contents .= " *\n";
      $contents .= " * This section defines absolute URLs to access the host CMS (Drupal or Mambo) and CiviCRM.\n";
      $contents .= " * IMPORTANT: Trailing slashes are required for CIVICRM_HTTPBASE and CIVICRM_RESOURCEBASE. \n";
      $contents .= " *\n";
      $contents .= " * EXAMPLE: if your Drupal site url is http://www.example.com/civicspace/\n";
      $contents .= " * these variables would be set as below. Modify as needed for your install. If you do not\n";
      $contents .= " * have clean url's turned on, make sure CIVICRM_MAINMENU is valid for your install. \n";
      $contents .= " * e.g. define( 'CIVICRM_MAINMENU'    , '/civicspace?q=civicrm' ) \n";
      $contents .= " */\n";
      $contents .= "define( 'CIVICRM_UF_BASEURL'  , 'http://". install_base_uri() ."/' );\n";
      $contents .= "define( 'CIVICRM_HTTPBASE'    , 'http://". install_base_uri() ."/' );\n";
      $contents .= "define( 'CIVICRM_RESOURCEBASE', 'http://". install_base_uri() ."/modules/civicrm/'     );\n";
      $contents .= "define( 'CIVICRM_MAINMENU'    , 'http://". install_base_uri() ."/civicrm/'           );\n";
      $contents .= "\n";
      $contents .= "/**\n";
      $contents .= " * CiviCRM Database settings:\n";
      $contents .= " *\n";
      $contents .= " * Define the version of MySQL you are running. \n";
      $contents .= " * CiviCRM has been optimized for MySQL 4.1, but will also run on many 4.0.x versions.\n";
      $contents .= " * If you are using a 4.0.x release of MySQL, you MUST change CIVICRM_MYSQL_VERSION to 4.0\n";
      $contents .= " *\n";
      $contents .= " * Define the database URL (CIVICRM_DSN) for the CiviCRM database and the Drupal/Mambo database\n";
      $contents .= " * Database URL format:\n";
      $contents .= " *      define( 'CIVICRM_DSN', 'mysql://crm_db_username:crm_db_password@db_server/crm_database?new_link=true');\n";
      $contents .= " *\n";
      $contents .= " * Drupal and CiviCRM can share the same database, or can be installed into separate databases.\n";
      $contents .= " *\n";
      $contents .= " * EXAMPLE: Drupal and CiviCRM running in the same database...\n";
      $contents .= " *      DB Name = drupal, DB User = drupal\n";
      $contents .= " *      define( 'CIVICRM_DSN'         , 'mysql://drupal:YOUR_PASSWORD@localhost/drupal?new_link=true' );\n";
      $contents .= " *\n";
      $contents .= " * EXAMPLE: Drupal and CiviCRM running in separate databases...\n";
      $contents .= " *      Drupal  DB Name = drupal, DB User = drupal\n";
      $contents .= " *      CiviCRM DB Name = civicrm, CiviCRM DB User = civicrm\n";
      $contents .= " *      define( 'CIVICRM_DSN'         , 'mysql://civicrm:YOUR_PASSWORD@localhost/civicrm?new_link=true' );\n";
      $contents .= " *\n";
      $contents .= " * define( 'CIVICRM_MYSQL_PATH', '/usr/bin/' );\n";
      $contents .= " *\n";
      $contents .= " * This stores the installed path of mysql. You will need to verify and modify this value if you are\n";
      $contents .= " * planning on using CiviCRMs built-in Database Backup utility. If you have shell access, you may be\n";
      $contents .= " * able to query the path by using one of the following commands:\n";
      $contents .= " * $ whereis mysql\n";
      $contents .= " * $ type mysql\n";
      $contents .= " */\n";
      $contents .= "define( 'CIVICRM_MYSQL_VERSION', ". $edit['mysql_version_confirmed'] ." );\n";
      $contents .= "define( 'CIVICRM_DSN'          , '". $edit['db_type'] .'://'. $edit['db_user_civicrm'] .':'. $edit['db_pass_civicrm'] .'@'. $edit['db_host_civicrm'] .'/'. $edit['db_db_civicrm'] ."?new_link=true' );\n";
      
      $result = array();
      $status = exec("which mysql", $result);
      $mysql_path = $result[0];
      if (strlen($mysql_path)) {
        substr($mysql_path, 0, strrpos($mysql_path, '/') + 1);
      }
      else {
        $mysql_path = '/usr/bin/';
      }
      
      $contents .= "define( 'CIVICRM_MYSQL_PATH', '". $mysql_path ."' );\n";
      $contents .= "\n";
      $contents .= "/**\n";
      $contents .= " * SMTP Server:\n";
      $contents .= " *\n";
      $contents .= " * If you are sending emails to contacts using CiviCRM's simple 'Send Email' functionality,\n";
      $contents .= " * uncomment the two lines below and enter your smtp server address here (e.g.'smtp.example.com').\n";
      $contents .= " * The standard STMP Port is 25, so you should only need to change that value if you find\n";
      $contents .= " * that your SMTP server is running on a non-standard port.\n";
      $contents .= " */\n";
      $contents .= "// define( 'CIVICRM_SMTP_SERVER' , 'YOUR SMTP SERVER' );\n";
      $contents .= "// define( 'CIVICRM_SMTP_PORT'   , 25 );\n";
      $contents .= "\n";

      $contents .= "/**\n";
      $contents .= " * Country Availability:\n";
      $contents .= " *\n";
      $contents .= " * The CIVICRM_COUNTRY_LIMIT option selects which countries are\n";
      $contents .= " * available to the users of this CiviCRM install. The format of this option\n";
      $contents .= " * is a comma-separated list of country ISO codes (US for United States, PL for\n";
      $contents .= " * Poland, etc.). If you're not sure what is the code for a given country, you\n";
      $contents .= " * can check it in the civicrm_country table and/or the xml/templates/civicrm_country.tpl\n";
      $contents .= " * file. The empty default does not limit the country list.\n";
      $contents .= " */\n";
      $contents .= "define( 'CIVICRM_COUNTRY_LIMIT' , 'US' );\n";
      $contents .= "/**\n";
      $contents .= " * Province availability:\n";
      $contents .= " *\n";
      $contents .= " * CiviCRM ships with a set of provinces derived from the ISO 3166-2 standard;\n";
      $contents .= " * the civicrm_state_province table includes almost 3800 provinces. The\n";
      $contents .= " * CIVICRM_PROVINCE_LIMIT option selects which countries' provinces are\n";
      $contents .= " * available to the users of this CiviCRM install. The format of this option\n";
      $contents .= " * is a space-separated list of country ISO codes (US for United States, PL for\n";
      $contents .= " * Poland, etc.). If you're not sure what is the code for a given country, you\n";
      $contents .= " * can check it in the civicrm_country table and/or the xml/templates/civicrm_country.tpl\n";
      $contents .= " * file. The default limits the province list to United States\n";
      $contents .= " */\n";
      $contents .= "define( 'CIVICRM_PROVINCE_LIMIT' , 'US' );\n";
      $contents .= "\n";
      $contents .= "\n";
      $contents .= "/**\n";
      $contents .= " * Default contact country\n";
      $contents .= " * \n";
      $contents .= " * When new contact is added, country field can be automatically populated wih\n";
      $contents .= " * chosen value. Use civicrm_country.id (primary key) value. United States is 1228.\n";
      $contents .= " */\n";
      $contents .= "define( 'CIVICRM_DEFAULT_CONTACT_COUNTRY_ID' , 1228 );\n";
      $contents .= "\n";
      $contents .= "/**\n";
      $contents .= " * Default Currency\n";
      $contents .= " *\n";
      $contents .= " * For clarity, all of the money amounts in the CiviCRM database must have\n";
      $contents .= " * their currencies specified. If the currency is not specified by the user\n";
      $contents .= " * (in the API call, while importing contributions, etc.) the system uses the\n";
      $contents .= " * below default currency.\n";
      $contents .= " *\n";
      $contents .= " * The currency must be specified by its ISO 4217\n";
      $contents .= " * code: http://en.wikipedia.org/wiki/ISO_4217\n";
      $contents .= " */\n";
      $contents .= "define( 'CIVICONTRIBUTE_DEFAULT_CURRENCY' , 'USD' );\n";
      $contents .= "\n";
      $contents .= "\n";
      $contents .= "/**\n";
      $contents .= " * Localisation:\n";
      $contents .= " *\n";
      $contents .= " * Localisation for CiviCRM's user interface is supported via GNU gettext i18n library.\n";
      $contents .= " * Each locale directory contains the translations for that language in .pot and .po files.\n";
      $contents .= " * To switch to a locale other than the default 'en_US', enter the directory name for the\n";
      $contents .= " * new locale (stored below civicrm/l10n directory). Locale format is 'langageCode_countryCode'\n";
      $contents .= " * (e.g. 'pl_PL' for Polish translation).\n";
      $contents .= " */\n";
      $contents .= "define( 'CIVICRM_LC_MESSAGES' , 'en_US' );\n";
      $contents .= "\n";
      $contents .= "/**\n";
      $contents .= " * Address Format:\n";
      $contents .= " *\n";
      $contents .= " * The format of address display and the source for address fields sequence in the edit forms.\n";
      $contents .= " *\n";
      $contents .= " * - Every {...token...} will be replaced with the token's value (keeping anything else inside\n";
      $contents .= " *   the curly braces intact).\n";
      $contents .= " * - If the value of a given token is missing, the whole {...} construct will be dropped.\n";
      $contents .= " * - Any {non-token} construct will be turned into non-token if have tokens on both sides\n";
      $contents .= " *   (i.e., will be dropped if on the beginning or end of any line after tokens are replaced).\n";
      $contents .= " *   If there's no city, \"{city}{, }{state_province}{ }{postal_code}\" will turn first into\n";
      $contents .= " *   \"{, }California{ }12345\" and then into \"California 12345\".\n";
      $contents .= " * - If after token replacements there are consecutive {non-token} constructs, the first\n";
      $contents .= " *   one's contents will replace the whole series. For example, if there's no state_province,\n";
      $contents .= " *   \"{city}{, }{state_province}{ }{postal_code}\" will first turn into \"San Francisco{, }{ }12345\"\n";
      $contents .= " *   and then into \"San Francisco, 12345\".\n";
      $contents .= " */\n";
      $contents .= "define( 'CIVICRM_ADDRESS_FORMAT' , '\n";
      $contents .= "{street_address}\n";
      $contents .= "{supplemental_address_1}\n";
      $contents .= "{supplemental_address_2}\n";
      $contents .= "{city}{, }{state_province}{ }{postal_code}\n";
      $contents .= "{country}\n";
      $contents .= "' );\n";
      $contents .= "\n";
      $contents .= "/**\n";
      $contents .= " * Date formatting:\n";
      $contents .= " *\n";
      $contents .= " * Formats for date display and input fields are configurable. Settings use standard POSIX sequences.\n";
      $contents .= " * Standard U.S. layouts are set by default. Adjust as needed to match your locale/requirements.\n";
      $contents .= " *\n";
      $contents .= " * Refer to CiviCRM Localisation documentation for more info. \n";
      $contents .= " */ \n";
      $contents .= "define( 'CIVICRM_DATEFORMAT_DATETIME', '%B %E%f, %Y %l:%M %P' );\n";
      $contents .= "define( 'CIVICRM_DATEFORMAT_FULL', '%B %E%f, %Y' );\n";
      $contents .= "define( 'CIVICRM_DATEFORMAT_PARTIAL', '%B %Y' );\n";
      $contents .= "define( 'CIVICRM_DATEFORMAT_YEAR', '%Y' );\n";
      $contents .= "define( 'CIVICRM_DATEFORMAT_QF_DATE', '%b %d %Y' );\n";
      $contents .= "define( 'CIVICRM_DATEFORMAT_QF_DATETIME', '%b %d %Y, %I : %M %P' );\n";
      $contents .= "\n";
      $contents .= "/**\n";
      $contents .= " * Money Display:\n";
      $contents .= " *\n";
      $contents .= " * Format for monetary values display.\n";
      $contents .= " * %c - currency symbol ('$')\n";
      $contents .= " * %C - currency ISO code ('USD')\n";
      $contents .= " * %a - monetary amount, formatted by properly set LC_MONETARY\n";
      $contents .= " *\n";
      $contents .= " * The final 'look' of the formatted amount depends on the defined\n";
      $contents .= " * CIVICRM_LC_MONETARY locale Locale format is 'langageCode_countryCode'.\n";
      $contents .= " * The specified locale must be supported by the underlying operating system.\n";
      $contents .= " */\n";
      $contents .= "define( 'CIVICRM_MONEYFORMAT', '%c %a' );\n";
      $contents .= "define( 'CIVICRM_LC_MONETARY', 'en_US' );\n";
      $contents .= "\n";
      $contents .= "/**\n";
      $contents .= " * Import - maximum file size:\n";
      $contents .= " *\n";
      $contents .= " * Default maximum Contact Import filesize is 1MB. You may increase this up to a hard-limit of 8MB.\n";
      $contents .= " * However, imports above 1MB will take a 'long time' and are server resource intensive.\n";
      $contents .= " * File size is expressed in bytes (1MB is entered as 1048576).\n";
      $contents .= " */\n";
      $contents .= "define( 'CIVICRM_MAX_IMPORT_FILESIZE' , 1048576);\n";
      $contents .= "\n";
      $contents .= "/**\n";
      $contents .= " * Mapping:\n";
      $contents .= " *\n";
      $contents .= " * Plug-ins are included for both Google and Yahoo mapping service providers. Choose the\n";
      $contents .= " * provider that has the best coverage for your commonly used locales by setting the Map\n";
      $contents .= " * CIVICRM_MAP_PROVIDER to either 'Google' or 'Yahoo'.\n";
      $contents .= " *\n";
      $contents .= " * For GOOGLE mapping - request an API key for your site here:\n";
      $contents .= " * http://www.google.com/apis/maps/signup.html\n";
      $contents .= " *\n";
      $contents .= " * When prompted for 'My Web Site URL' - enter the url for your CiviCRM menu followed by\n";
      $contents .= " * the path '/contact/search'. Your API Key will be generated and displayed on the next page.\n";
      $contents .= " *\n";
      $contents .= " * EXAMPLE: if your Drupal site url is http://www.example.com/civicspace/ you would enter\n";
      $contents .= " * 'http://www.example.com/civicspace/civicrm/contact/search'\n";
      $contents .= " *\n";
      $contents .= " * For YAHOO mapping - request an Application ID for your site here:\n";
      $contents .= " * http://api.search.yahoo.com/webservices/register_application\n";
      $contents .= " *\n";
      $contents .= " * Enter either your Google API key OR Yahoo Application ID in the CIVICRM_MAP_API_KEY\n";
      $contents .= " * setting below.\n";
      $contents .= " *\n";
      $contents .= " * IMPORTANT: Both mapping providers require that Contact addresses include latitude\n";
      $contents .= " * and longitude. You can populate these manually, or you must enable one of the\n";
      $contents .= " * automatic Geocode lookup methods described in the next section.\n";
      $contents .= " *\n";
      $contents .= " */\n";
      $contents .= "define('CIVICRM_MAP_PROVIDER','');\n";
      $contents .= "define('CIVICRM_MAP_API_KEY', '');\n";
      $contents .= "\n";
      $contents .= "/**\n";
      $contents .= " * Geocode (latitude and longitude) Lookup:\n";
      $contents .= " *\n";
      $contents .= " * CiviCRM can be configured to automatically lookup and insert\n";
      $contents .= "latitude and longitude for contact\n";
      $contents .= " * addresses. The current version offers three methods for this lookup:\n";
      $contents .= " * - local lookup in the Drupal zipcodes table (requires this table to be installed in the\n";
      $contents .= " *   civicrm_db)\n";
      $contents .= " *      define('CIVICRM_GEOCODE_METHOD', 'CRM_Utils_Geocode_ZipTable' );\n";
      $contents .= " *\n";
      $contents .= " * - remote geocode lookup using Yahoo\n";
      $contents .= " *      define('CIVICRM_GEOCODE_METHOD', 'CRM_Utils_Geocode_Yahoo' );\n";
      $contents .= " *\n";
      $contents .= " * NOTE: You must request and enter a Yahoo Application ID to use Yahoo's geocode lookup service.\n";
      $contents .= " * Enter this value in the CIVICRM_MAP_API_KEY above if you haven't already done so (the same ID\n";
      $contents .= " * is used for mapping and geocode lookups).\n";
      $contents .= " *\n";
      $contents .= " * - remote geocode lookup using geocoder.us\n";
      $contents .= " *      define('CIVICRM_GEOCODE_METHOD', 'CRM_Utils_Geocode_RPC' );\n";
      $contents .= " *\n";
      $contents .= " * NOTE: Both remote lookup methods involve moderate to significant network overhead and have\n";
      $contents .= " * usage limits. Yahoo's lookup is a bit faster, but neither method should be enabled when\n";
      $contents .= " * Importing more than a few hundred contacts.\n";
      $contents .= " * \n";
      $contents .= " * You may also create and call your own class using the interface defined at\n";
      $contents .= " * 'CRM_Utils_Geocode_API'.\n";
      $contents .= " */\n";
      $contents .= "define('CIVICRM_GEOCODE_METHOD', '' );\n";
      $contents .= "\n";
      $contents .= "/**\n";
      $contents .= " * Automatically Check for New CiviCRM Versions\n";
      $contents .= " *\n";
      $contents .= " * CiviCRM can be configured to connect periodically to the OpenNGO website and\n";
      $contents .= " * check for the availability of new versions. Set this value to true if you\n";
      $contents .= " * want this install to perform such checks (the info about new versions will\n";
      $contents .= " * be displayed on the main Administer CiviCRM control panel).\n";
      $contents .= " */\n";
      $contents .= "define('CIVICRM_VERSION_CHECK', false);\n";
      $contents .= "\n";
      $contents .= "/**\n";
      $contents .= " * Payment Processor Settings\n";
      $contents .= " *\n";
      $contents .= " * If you are using CiviContribute for Online Contributions, you must obtain a Payment Processor\n";
      $contents .= " * (merchant) account and configure your site and the settings below with that account information.\n";
      $contents .= " *\n";
      $contents .= " * You should start with a Test Server (e.g. Sandbox) account, and configure both the LIVE and TEST\n";
      $contents .= " * settings below using your test (sandbox) account info. Once you are ready to go live, update\n";
      $contents .= " * the LIVE settings to use your live account info. Consult your Payment Processor's documentation\n";
      $contents .= " * and CiviCRM Payment Processor Configuration documentation (http://objectledge.org/confluence/display/CRM/CiviContribute+Payment+Processor+Configuration)\n";
      $contents .= " * for details on these settings.\n";
      $contents .= " */\n";
      $contents .= "define( 'CIVICRM_CONTRIBUTE_PAYMENT_PROCESSOR'     , '' );\n";
      $contents .= "// Valid values are 'PayPal' (Website Payments Pro), 'PayPal_Express', and 'Moneris'.\n";
      $contents .= "\n";
      $contents .= "define( 'CIVICRM_CONTRIBUTE_PAYMENT_RESPONSE_EMAIL', '' );\n";
      $contents .= "// The FROM email address for all automatic payment response (receipt) emails.\n";
      $contents .= "\n";
      $contents .= "/*\n";
      $contents .= " * TEST Payment Server (Sandbox) Settings\n";
      $contents .= " */\n";
      $contents .= "// PayPal ONLY - path to the .cert AND .ppd files (SDK API Profile files)\n";
      $contents .= "define( 'CIVICRM_CONTRIBUTE_PAYMENT_TEST_CERT_PATH'     , '');\n";
      $contents .= "\n";
      $contents .= "// API Password (PayPal) or API Token (Moneris)\n";
      $contents .= "define( 'CIVICRM_CONTRIBUTE_PAYMENT_TEST_PASSWORD'      , '' );\n";
      $contents .= "\n";
      $contents .= "// Authentication key. For PayPal - use Administer CiviCRM >> Create PayPal API Profile to get this value.\n";
      $contents .= "// For Moneris - storeid.\n";
      $contents .= "define( 'CIVICRM_CONTRIBUTE_PAYMENT_TEST_KEY'           , '' );\n";
      $contents .= "\n";
      $contents .= "/*\n";
      $contents .= " * LIVE Payment Server Settings\n";
      $contents .= " */\n";
      $contents .= "// PayPal ONLY - path to the .cert AND .ppd files (SDK API Profile files)\n";
      $contents .= "define( 'CIVICRM_CONTRIBUTE_PAYMENT_CERT_PATH'     , '' );\n";
      $contents .= "\n";
      $contents .= "// API Password (PayPal) or API Token (Moneris)\n";
      $contents .= "define( 'CIVICRM_CONTRIBUTE_PAYMENT_PASSWORD'      , '' );\n";
      $contents .= "\n";
      $contents .= "// Authentication key. For PayPal - use Administer CiviCRM >> Create PayPal API Profile to get this value.\n";
      $contents .= "// For Moneris - storeid.\n";
      $contents .= "define( 'CIVICRM_CONTRIBUTE_PAYMENT_KEY'           , '' );\n";
      $contents .= "\n";
      $contents .= "/**\n";
      $contents .= " * Multi-site Support\n";
      $contents .= " *\n";
      $contents .= " * CiviCRM uses Domain ID keys to allow you to store separate data sets for multiple sites\n";
      $contents .= " * using the same codebase.\n";
      $contents .= " *\n";
      $contents .= " * Refer to the 'Multi-site Support' section of the Installation Guide for more info.\n";
      $contents .= " */\n";
      $contents .= "define('CIVICRM_DOMAIN_ID' , 1 );\n";
      $contents .= "\n";
      $contents .= "/**\n";
      $contents .= " * Debugging\n";
      $contents .= " *\n";
      $contents .= " * Enable CIVICRM_DEBUG (value = 1) when you need to use one of the debug-related tools. These are \n";
      $contents .= " * triggered via URL parameters - IF CIVICRM_DEBUG is turned on.\n";
      $contents .= " *\n";
      $contents .= " * Debugging tools:\n";
      $contents .= " * Smarty Debug Window - Loads all variables available to the current page template into a pop-up\n";
      $contents .= " * window. To trigger, add '&smartyDebug=1' to any CiviCRM URL query string.\n";
      $contents .= " *\n";
      $contents .= " * Session Reset - Resets all values in your client session. To trigger, add '&sessionReset=2'\n";
      $contents .= " *\n";
      $contents .= " * Directory Cleanup - Empties template cache and/or upload file folders.\n";
      $contents .= " *  To empty template cache (civicrm/templates_c folder), add '&directoryCleanup=1'\n";
      $contents .= " *  To remove temporary upload files (civicrm/upload folder), add '&directoryCleanup=2'\n";
      $contents .= " *  To cleanup both, add '&directoryCleanup=3'\n";
      $contents .= " *\n";
      $contents .= " * WARNING: Do not leave debugging enabled by default as it can be used to expose configuration\n";
      $contents .= " * information to unauthorized browsers.\n";
      $contents .= " */\n";
      $contents .= "define( 'CIVICRM_DEBUG', 0 );\n";
      $contents .= " \n";
      $contents .= "\n";
      $contents .= "/**\n";
      $contents .= " * Mailer settings\n";
      $contents .= " *\n";
      $contents .= " * CIVICRM_MAILER_SPOOL_PERIOD -  Number of seconds between delivery attempts\n";
      $contents .= " * for new outgoing mailings. (Used for CiviMail only.)\n";
      $contents .= " */\n";
      $contents .= "define( 'CIVICRM_MAILER_SPOOL_PERIOD', 180);\n";
      $contents .= "\n";
      $contents .= "define( 'CIVICRM_VERP_SEPARATOR', '.' );\n";
      $contents .= "\n";
  $contents .= "/**\n";
  $contents .= " *\n";
  $contents .= " * Do not change anything below this line. Keep as is\n";
  $contents .= " *\n";
  $contents .= " */\n";
  $contents .= "\n";
  $contents .= "\$include_path = '.'        . PATH_SEPARATOR .\n";
  $contents .= "                \$civicrm_root . PATH_SEPARATOR .\n";
  $contents .= "                \$civicrm_root . DIRECTORY_SEPARATOR . 'packages' . PATH_SEPARATOR .\n";
  $contents .= "                get_include_path( );\n";
  $contents .= "set_include_path( \$include_path );\n";
  $contents .= "\n";
  $contents .= "define( 'CIVICRM_SMARTYDIR'  , \$civicrm_root . DIRECTORY_SEPARATOR . 'packages' . DIRECTORY_SEPARATOR . 'Smarty' . DIRECTORY_SEPARATOR );\n";
  $contents .= "define( 'CIVICRM_TEST_DIR'   , \$civicrm_root . DIRECTORY_SEPARATOR . 'test'   . DIRECTORY_SEPARATOR );\n";
  $contents .= "define( 'CIVICRM_DAO_DEBUG'  , 0 );\n";
  $contents .= "define( 'CIVICRM_TEMPLATEDIR', \$civicrm_root . DIRECTORY_SEPARATOR . 'templates'   );\n";
  $contents .= "define( 'CIVICRM_PLUGINSDIR' , \$civicrm_root . DIRECTORY_SEPARATOR . 'CRM' . DIRECTORY_SEPARATOR . 'Core' . DIRECTORY_SEPARATOR . 'Smarty' . DIRECTORY_SEPARATOR . 'plugins' );\n";
  $contents .= "\n";
  $contents .= "define( 'CIVICRM_GETTEXT_CODESET'    , 'utf-8'   );\n";
  $contents .= "define( 'CIVICRM_GETTEXT_DOMAIN'     , 'civicrm' );\n";
  $contents .= "define( 'CIVICRM_GETTEXT_RESOURCEDIR', \$civicrm_root . DIRECTORY_SEPARATOR . 'l10n' );\n";
  $contents .= "\n";
  $contents .= "if ( function_exists( 'variable_get' ) && variable_get('clean_url', '0') != '0' ) {\n";
  $contents .= "    define( 'CIVICRM_CLEANURL', 1 );\n";
  $contents .= "} else {\n";
  $contents .= "    define( 'CIVICRM_CLEANURL', 0 );\n";
  $contents .= "}\n";
  }

  return $contents;
}


function install_already_installed_page() {
  $output  = '';
  $output .= install_page_header('CivicSpace has already been installed.');
  $output .= install_checklist('Installation already completed!');
  $output .= install_step_main_content('Installation already completed!');
  $output .= install_page_footer();
  return $output;
}


function install_step_page($title) {
  $output  = '';
  $output .= install_page_header($title);
  $output .= install_checklist($title);
  $output .= install_step_main_content($title);
  $output .= install_page_footer();
  return $output;
}


function install_step_main_content($title, $percent = NULL) {
  $edit = isset($_POST['edit']) ? $_POST['edit'] : NULL;

  $output  = "\n\n";
  $output .= '    <div id="container">'."\n\n";
  $output .= '      <div id="main-content">'."\n\n";
  if ($title == 'Server check-up' || $title == 'Database setup' || $title == 'Finishing up' ) {  
    $output .= '        <h2 class="step-title hide">'. $title .'</h2>'."\n\n";
  } else {
    $output .= '        <h2 class="step-title">'. $title .'</h2>'."\n\n";
  }
  if (!$edit) {
    $output .= install_step_pretext($title);   // don't output pretext if there are messages       
  }
  $output .= install_step_messages($title);
  $output .= install_step_explanation($title, $percent);
  $output .= '        <div class="install-form">'."\n\n";
  $output .= install_step_form($title);
  $output .= '        </div>'."\n\n";
  
  $output .= '      </div>'."\n\n";  // closes <div id="main-content">
  $output .= '    </div>'."\n\n";  // closes <div id="container">
  return $output;
}

function install_step_pretext($title) {
  $output = "\n";
  switch ($title) {
    case 'Introduction':
      $output .= ''."\n";
      break;
    case 'Server check-up':
      $output .= '<p>We\'re going to run a few checks to make sure that your server is setup correctly for CivicSpace...</p>';
      break;
    case 'Install':
      $output .= '<h4>Multi-Site Install</h4><p>Optional multi-site install. If you want to set up a single site, you can ignore this page and click on <strong>Setup database</strong></p>';
      break;
    case 'Database setup':
      $output .= '<p>Ok, now that your server is all set, we\'re going to setup the connection to your database. If you need help, feel free to refer to these <a href="javascript:alert(\'detailed instructions\');">detailed instructions</a>.</p>';
      $output .= '<p>Let\'s start with your database username and password:</p>';
      break;
    case 'Setting up database...':
      $output .= "\n";
      break;
    case 'Finishing up';
      $output .= "\n";
      break;
  }
  return $output ."\n\n";
}

function install_step_explanation($title, $percent = NULL) {
  $output = "\n";
  switch ($title) {
    case 'Introduction':
      $output .= '        <p>Welcome to CivicSpace! We\'re dedicated to making your experience as pleasant as possible and encourage you to send us your feedback  (once the installation process has been completed!).</p>'."\n";
      $output .= '        <p>But, before we begin, we need to take care of a few technical details pertaining to your server environment:'."\n";
      $output .= '        </p>'."\n\n";
      $output .=          theme('item_list', array('First, you will need a <strong>database</strong> with a <strong>valid username and password</strong>. <a href="http://www.civicspacelabs.org/home/installer_help/general/db_account_creation" class="help-link">Where do I find this?</a>',
                          'Second, you need to <strong>turn off PHP\'s "safe mode"</strong>. <a href="http://www.civicspacelabs.org/home/installer_help/082/safe_mode" class="help-link">How do I do this?</a>', 
                          'Third, we recommended that you <strong>set your server\'s PHP memory limit</strong> to at least 24M. <a href="http://www.civicspacelabs.org/installer_help/082/memory_check" class="help-link">Ok, how?</a>', 
                          'Finally, you may need to <strong>set some file permissions</strong>: 
                          <ul style="margin-bottom: 1.2em;">
                          <li><strong><em><code>sites/default/settings.php</code></em></strong> must be writable</li>
                          <li><strong><em><code>sites/default/civicrm.settings.php</code></em></strong> must be writable</li>
                          <li>the <strong><em><code>sites/</code></em></strong> directory must be writable</li>
                          <li>the <strong><em><code>files/</code></em></strong> directory must be writable and readable</li> 
                          <li>the <strong><em><code>files/civicrm</code></em></strong> directory must be writable and readable</li> 
                          <li>the <strong><em><code>files/civicrm/upload</code></em></strong> directory must be writable and readable</li> 
                          <li>the <strong><em><code>files/civicrm/templates_c</code></em></strong> directory must be writable and readable</li> 
                          <li>the <strong><em><code>CURL</code></em></strong> PHP extension will need to be enabled to use massmailer (optional)</li>
                          </ul>
                          <p>If you are unsure about the above details mean, proceed with the installation for now.  If the permissions do need to be changed (or your anything else, for that matter), you will be given more detailed instructions after this installer checks and detects what needs to be changed.'))."\n";
      break;
    case 'Server check-up':
      $output .= ''."\n";
      break;
    case 'Database setup':
/*      $output .= "\n\n";
      $output .= '         <p>In order for this step to proceed correctly, three conditions must be met:</p>'."\n";
      $output .= '            <ol>'."\n";
      $output .= '                <li>'."\n";
      $output .= '                    You must provide a valid MySQL database account and password.'."\n";
      $output .= '                </li>'."\n";
      $output .= '                <li>'."\n";
      $output .= '                    The database that you specify must already exist.'."\n";
      $output .= '                </li>'."\n";
      $output .= '                <li>'."\n";
      $output .= '                    There can no table name collisions between your database and another using the same account.'."\n";
      $output .= '                </li>'."\n";
      $output .= '            </ol>'."\n";
      $output .= '         </p>'."\n"; */
      break;
    case 'Setting up database...':
      $output .= "\n\n";
      $output .= '     <p>The database for your CivicSpace site is currently being populated. Please wait as this process may take several minutes...</p>'."\n";
      $output .= '     <h3>'. $percent .'% done...</h3>'."\n";
      $output .= '     <div class="progressbar">'."\n";
      $output .= '       <div style="width: '. $percent .'%;" class="foreground"></div>'."\n";
      $output .= '     </div>'."\n";
      break;
    case 'Finishing up';
      $output .= "\n";
      break;
  }
  return $output ."\n\n";
}


// If nothing else, this form generates buttons for the next step of the installation process.
function install_step_form($title) {
  $form = '';
  switch ($title) {
    case 'Introduction':
      $form .= '        '. form(form_button("Begin installation")) ."\n";
      break;
    case 'Server check-up':
      $status = _install_check_server();
      if ($status['server_ok']) {
        $form .= form(form_button('Install'));
//        $form .= form(form_button('Configure database'));
      }
      else {
        $form .= form(form_button('Try again'));
      }
      break;
    case 'Install':
      $edit = isset($_POST['edit']) ? $_POST['edit'] : NULL;
      $form .= install_multisite_form($edit);
      
      break;
    case 'Database setup':
      $edit = isset($_POST['edit']) ? $_POST['edit'] : NULL;
      if ($edit) {
        $form .= install_database_form($edit);
      }
      else {
        $form .= install_database_form();
      }
      break;
    case 'Finishing up':
      $status = _install_check_finish();
      if ($status['server_ok']){
        $button = form_button('Configure site...');
        // The form here is not really meant to post any data to the CivicSpace configuration
        // wizard page (which is the default page that shows up at {'http://'. install_base_uri() .'/'}
        // Be careful if modifying configure.module, wizard.inc, or the install.php sequence of pages (and
        // associated logic.
        $form .= form($button, 'POST', 'http://'. install_base_uri() .'/');
      }
      else {
        $form .= form(form_button('Try checks again'));
        $backURL = install_base_uri();
        $form .= "<p><a href='http://$backURL'>Skip these checks and go to the configuration wizard, I understand the risks involved (Click here if some checks \"stall\" and you cannot continue).</a></p>";
      }
      break;
    case 'Installation already completed!':
      $button = '<input type="submit" class="form-button" value="Go to site">'."\n";
      $form .= form($button, 'GET', 'http://'. install_base_uri() .'/')."\n";
      break;
    default:
      $form .= "\n\n";
      break;
  }
  return $form;  
}


function install_step_messages($title) {
  $messages = "\n";
  switch ($title) {
    case 'Installation already completed!':
      $messages .= '          <div class="messages">'."\n";
      $messages .= _install_msg_failed('The installation process has detected that CivicSpace has already been installed.  You are only allowed to run the installation process once for an installation.');
      $messages .= '          </div>'."\n";
      break;
    case 'Server check-up':
      $status = _install_check_server();
      $messages .= $status['messages'];
      break;
    case 'Install':
    
      break;
    case 'Database setup':
      $edit = isset($_POST['edit']) ? $_POST['edit'] : NULL;
      if ($edit && !isset($edit['multisite_step'])) {
        $failed_status = '';
        
        if (!install_test_dbinfo($edit, $failed_status)) {
          $messages .= "\n".'          <div class="messages">'."\n";
          
          if ($failed_status == 'invalid_user' || $failed_status == 'invalid_pass' || $failed_status == 'invalid_user_civicrm' || $failed_status == 'invalid_pass_civicrm') {
            if ($failed_status == 'invalid_user') {
              $messages .= _install_msg_failed('The user name you submitted for connecting to the CivicSpace database is not compatible with CivicSpace.  Please select one that is 1-16 characters along and consists only of letters, digits, \'_\', and \'-\'.  If your database account has been set up with this user name, we recommend that you change it to the format described above if you wish to install CivicSpace with this installer.', NULL, 'http://www.civicspacelabs.org/installer_help/082/invalid_dbuser');
            }
            if ($failed_status == 'invalid_pass') {
              $messages .= _install_msg_failed('The password you submitted for connecting to the CivicSpace database is not compatible with CivicSpace.  Please select one that consists only of letters, digits, \'_\', and \'-\'.', NULL, 'http://www.civicspacelabs.org/installer_help/082/invalid_dbpass');
            }
            if ($failed_status == 'invalid_user_civicrm') {
              $messages .= _install_msg_failed('The user name you submitted for connecting to the CiviCRM database is not compatible with CivicSpace.  Please select one that is 1-16 characters along and consists only of letters, digits, \'_\', and \'-\'.  If your database account has been set up with this user name, we recommend that you change it to the format described above if you wish to install CivicSpace with this installer.', NULL, 'http://www.civicspacelabs.org/installer_help/082/invalid_dbuser');
            }
            if ($failed_status == 'invalid_pass_civicrm') {
              $messages .= _install_msg_failed('The password you submitted for connecting to the CiviCRM database is not compatible with CivicSpace.  Please select one that consists only of letters, digits, \'_\', and \'-\'.', NULL, 'http://www.civicspacelabs.org/installer_help/082/invalid_dbpass');
            }
            $messages .= "\n          </div>\n";
          }
          else {
            if ($failed_status == 'connection') {
              $messages .= _install_msg_failed('The installer was not able to create a connection to the CivicSpace database with the information you submitted.  Please make sure your database hostname, username, and password are correct.', NULL, 'http://www.civicspacelabs.org/installer_help/082/db_connection');
              $messages .= "\n          </div>\n";
            }
            else {
              $messages .= _install_msg_successful('The installer was able to connect to the CivicSpace database with the database hostname, username, and password that you submitted.');

              if ($failed_status == 'database_name') {
                $messages .= _install_msg_failed('There is no database by the name <em>'. $edit['db_db'] .'</em>.  '. 'Please make sure you have the correct database name.', NULL, 'http://www.civicspacelabs.org/installer_help/082/invalid_db');
                $messages .= "\n          </div>\n";
              }
              else if ($failed_status == 'database_name_civicrm') {
                $messages .= _install_msg_failed('There is no database by the name <em>'. $edit['db_db_civicrm'] .'</em>.  '. 'Please make sure you have the correct database name.', NULL, 'http://www.civicspacelabs.org/installer_help/082/invalid_db');
                $messages .= "\n          </div>\n";
              }
              else {
                $messages .= _install_msg_successful('The installer was able to access the database specified by the database name you gave.');

                if ($failed_status == 'collision') {
                  $collision_msg = 'The installer encountered a naming collision. ';

                  if (trim($edit['db_prefix']) != '') {
                    $collision_msg .= ' You should select a prefix different from <em>'. $edit['db_prefix'] .'</em> since table names with this prefix already exist. ';
                  }
                  else {
                    $collision_msg .= ' You should enter a prefix since one or more non-prefixed table names refer to existing tables. ';
                  }
                  $messages .= _install_msg_failed($collision_msg, NULL, 'http://www.civicspacelabs.org/installer_help/082/prefix_collision');
                  break;
                }
                else if ($failed_status == 'collision_civicrm') {
                  $collision_msg = 'The installer found that CiviCRM is already installed in the specified database. The CiviCRM database will not be installed again. ';

                  $messages .= _install_msg_failed($collision_msg, NULL, 'http://www.civicspacelabs.org/installer_help/082/civicrm_installed');
                }
                else if ($failed_status == 'database_version_civicrm') {
                  $collision_msg = 'The installer found that your database version is not supported by CiviCRM. The CiviCRM database will not be installed and you can not enable the civicrm module. ';

                  $messages .= _install_msg_failed($collision_msg, NULL, 'http://www.civicspacelabs.org/installer_help/082/civicrm_mysql_version');
                }
                else { // By process of elimination, error is failure to run "show tables" in _install_tablenames_collide.
                  $messages .= _install_msg_failed('The installer could not query the database to see if conflicting table names already exist.  This problem may be occurring due to a lack of privileges for your database account.', NULL, 'http://www.civicspacelabs.org/installer_help/082/prefix_collision');
                }

                $messages .= "\n          </div>\n";
              }
            }
          }
        }
      }
      break;
    case 'Finishing up':
      if ($_POST['op'] == 'Cancel installation') {
        $messages .= '          <div class="messages">'."\n";
        $messages .= _install_msg_failed('You have chosen to abort the installation process. You may run this installation process at a later time or, if you wish, attempt to install CivicSpace manually at a later time.');
        $messages .= '          </div>'."\n";
      }
      else {
        $status = _install_check_finish();
        $messages .= $status['messages'];
      }
      break;
    default:
      break;
  }
  return $messages;
}


function _install_check_server() {
  $status = array('server_ok' => TRUE, 'messages' => '');
  $status['messages'] .= '          <div class="messages">'."\n";
  $status['messages'] .= '            '. install_warning_messages() ."\n";
        
  // need to clear PHP's stat cache for files since they might be changing between page serves
  clearstatcache();
      
  // check for safe mode
  if (ini_get('safe_mode')) {
    $status['messages'] .= _install_msg_failed('Your web-server\'s PHP is configured with "safe_mode" set to "On". CivicSpace relies on "safe_mode" being off for several functions.', NULL, 'http://www.civicspacelabs.org/home/installer_help/082/safe_mode');
    // TODO: make a page to link to for this error message
  }
  else {
    $status['messages'] .= _install_msg_successful('PHP\'s "safe_mode" is set to "Off".');
  }

  // check that 'settings.php' is writable
  if (!is_writable('sites/default/settings.php')) {
    $status['server_ok'] = FALSE;
    $status['messages'] .= _install_msg_failed('<strong><em><code>sites/default/settings.php</code></em></strong> is not writeable.', NULL, 'http://www.civicspacelabs.org/installer_help/082/settings_perms') ."\n";
  }
  else {
    $status['messages'] .= _install_msg_successful('<strong><em><code>sites/default/settings.php</code></em></strong> is writable. <p>Please <strong>make sure you turn off write permissions to this file when you are done with the installation</strong>. (We\'ll remind you at the end of the installation.)</p>');
  }

  // check that 'config.inc.php' is writable
  if (!is_writable('sites/default/civicrm.settings.php')) {
    $status['server_ok'] = FALSE;
    $status['messages'] .= _install_msg_failed('<strong><em><code>sites/default/civicrm.settings.php</code></em></strong> is not writeable.', NULL, 'http://www.civicspacelabs.org/installer_help/082/civicrm_perms') ."\n";
  }
  else {
    $status['messages'] .= _install_msg_successful('<strong><em><code>sites/default/civicrm.settings.php</code></em></strong> is writable. <p>Please <strong>make sure you turn off write permissions to this file when you are done with the installation</strong>. (We\'ll remind you at the end of the installation.)</p>');
  }

  // check that the sites directory is writable
  if (!(is_writable('sites') && is_readable('sites'))) {
    $status['server_ok']  = FALSE;
    $status['messages'] .= _install_msg_failed('The <strong><em><code>sites/</code></em></strong> directory is not readable and writeable.', NULL, 'http://www.civicspacelabs.org/installer_help/082/sites_perms');
  }
  else {
    $status['messages'] .= _install_msg_successful('The <strong><em><code>sites/</code></em></strong> directory is readable and writable. <p>Please <strong>make sure you turn off write permissions to this directory when you are done with the installation</strong>. (We\'ll remind you at the end of the installation.)</p>');
  }
  
  // check that the files directory is writable
  if (!(is_writable('files') && is_readable('files'))) {
    $status['server_ok']  = FALSE;
    $status['messages'] .= _install_msg_failed('The <strong><em><code>files/</code></em></strong> directory is not readable and writeable.', NULL, 'http://www.civicspacelabs.org/installer_help/082/files_perms');
  }
  else {
    $status['messages'] .= _install_msg_successful('The <strong><em><code>files/</code></em></strong> directory is readable and writable. It should remain writable for file uploads and galleries.');
  }
  
  // check that the files/civicrm directory is writable
  if (!(is_writable('files/civicrm') && is_readable('files/civicrm'))) {
    $status['server_ok']  = FALSE;
    $status['messages'] .= _install_msg_failed('The <strong><em><code>files/civicrm</code></em></strong> directory is not readable and writeable.', NULL, 'http://www.civicspacelabs.org/installer_help/082/files_civicrm_perms');
  }
  else {
    $status['messages'] .= _install_msg_successful('The <strong><em><code>files/civicrm</code></em></strong> directory is readable and writable. It should remain writable.');
  }
  
  // check that the files/civicrm directory is writable
  if (!(is_writable('files/civicrm/templates_c') && is_readable('files/civicrm/templates_c'))) {
    $status['server_ok']  = FALSE;
    $status['messages'] .= _install_msg_failed('The <strong><em><code>files/civicrm/templates_c</code></em></strong> directory is not readable and writeable.', NULL, 'http://www.civicspacelabs.org/installer_help/082/files_civicrm_templates_c_perms');
  }
  else {
    $status['messages'] .= _install_msg_successful('The <strong><em><code>files/civicrm/templates_c</code></em></strong> directory is readable and writable. It should remain writable.');
  }

  // check that the files/civicrm directory is writable
  if (!(is_writable('files/civicrm/upload') && is_readable('files/civicrm/upload'))) {
    $status['server_ok']  = FALSE;
    $status['messages'] .= _install_msg_failed('The <strong><em><code>files/civicrm/upload</code></em></strong> directory is not readable and writeable.', NULL, 'http://www.civicspacelabs.org/installer_help/082/files_civicrm_upload_perms');
  }
  else {
    $status['messages'] .= _install_msg_successful('The <strong><em><code>files/civicrm/upload</code></em></strong> directory is readable and writable. It should remain writable.');
  }

  // phplist check - needs curl
    if (!function_exists('curl_init')) {
      $status['messages'] .= _install_msg_warning('The <strong><em><code>CURL</code></em></strong> PHP extension was not found.  Without this extension the massmailer module will not work.  Enable this extension in php.ini or talk to your hosting provider to have this extension enabled.');
    }
    else {
      $status['messages'] .= _install_msg_successful('The <code>CURL</code> PHP extension was enabled.');
    }
  
  $status['messages'] .= "          </div>\n";
  return $status;
}


// Rip of above function to check to make sure config files ARE NOT writable.
function _install_check_finish() {
  $status = array('server_ok' => TRUE, 'messages' => '');
  $status['messages'] .= '<p>We\'re going to run a few checks to make sure that your CivicSpace installation is secure...</p>';
  $status['messages'] .= '          <div class="messages">'."\n";

  // need to clear PHP's stat cache for files since they might be changing between page serves
  clearstatcache();

  // check that 'settings.php' is NOT writable
  if (is_writable('sites/default/settings.php')) {
    $status['server_ok'] = FALSE;
    $status['messages'] .= _install_msg_failed('<strong><em><code>sites/default/settings.php</code></em></strong> is writeable and can be a security hazard.', NULL, 'http://civicspacelabs.org/home/installer_help/083/civicrm_final_perms') ."\n";
  }
  else {
    $status['messages'] .= _install_msg_successful('<strong><em><code>sites/default/settings.php</code></em></strong> is NOT writeable. <p>Please keep this file unwriteable for your security.</p>');
  }

  // check that 'config.settings.php' is NOT writable
  if (is_writable('sites/default/civicrm.settings.php')) {
    $status['server_ok'] = FALSE;
    $status['messages'] .= _install_msg_failed('<strong><em><code>sites/default/civicrm.settings.php</code></em></strong> is writeable and can be a security hazard.', NULL, 'http://civicspacelabs.org/home/installer_help/083/civicrm_final_perms') ."\n";
  }
  else {
    $status['messages'] .= _install_msg_successful('<strong><em><code>sites/default/civicrm.settings.php</code></em></strong> is NOT writeable. <p>Please keep this file unwriteable for your security.</p>');
  }

  // check that the sites directory is NOT writable
  if (is_writable('sites')) {
    $status['server_ok']  = FALSE;
    $status['messages'] .= _install_msg_failed('The <strong><em><code>sites/</code></em></strong> directory is writeable and can be a security hazard..', NULL, 'http://civicspacelabs.org/home/installer_help/083/civicrm_final_perms');
  }
  else {
    $status['messages'] .= _install_msg_successful('The <strong><em><code>sites/</code></em></strong> directory is NOT writable. <p>Please keep this folder unwriteable for your security.</p>');
  }

  $status['messages'] .= "          </div>\n";
  return $status;
}

function _install_closing_queries($edit) {
  //global $db_url, $db_prefix;
  //$db_url['default'] = $edit['db_user'] .':'. $edit['db_pass'] .'@'. $edit['db_host'] .'/'. $edit['db_db'];
  //$db_url['civicrm'] = $edit['db_user_civicrm'] .':'. $edit['db_pass_civicrm'] .'@'. $edit['db_host_civicrm'] .'/'. $edit['db_db_civicrm'];
  //$db_prefix = $edit['db_prefix'];
  
  //$GLOBALS['db_url']['default'] = $edit['db_user'] .':'. $edit['db_pass'] .'@'. $edit['db_host'] .'/'. $edit['db_db'];
  //$GLOBALS['db_url']['civicrm'] = $edit['db_user_civicrm'] .':'. $edit['db_pass_civicrm'] .'@'. $edit['db_host_civicrm'] .'/'. $edit['db_db_civicrm'];
  //$GLOBALS['db_prefix'] = $edit['db_prefix'];

  // Make a random password, this makes it impossible for nasties to use PHPList
  // admin interface for sending spam by using a default password.
  // Massmailer will automatically reset this password on init.
  $rand_pass = rand(10000000,10000000000); 
  _install_db_query($edit, "INSERT INTO phplist_admin VALUES (1,'admin','admin','','2002-05-24 16:06:33','2002-05-24 16:06:33','','$rand_pass','2002-05-24',1,0)"); 
  
  _install_db_query($edit, "INSERT INTO phplist_config (value, item) VALUES ('". substr($_SERVER['PHP_SELF'], 0, strrpos($_SERVER['PHP_SELF'], '/') + 1) ."?q=phplist', 'preferencesurl')");
  _install_db_query($edit, "INSERT INTO phplist_config (value, item) VALUES ('". substr($_SERVER['PHP_SELF'], 0, strrpos($_SERVER['PHP_SELF'], '/') + 1) ."?q=phplist', 'unsubscribeurl')");
 
      
  // INSERTS below necessary for CiviCRM integration w/ massmailer, volunteer, and eventfinder
 _install_db_query($edit, "UPDATE civicrm_location_type SET is_default = 0 WHERE id = 2;");
 _install_db_query($edit, "UPDATE civicrm_location_type SET is_default = 1 WHERE id = 1;");

  _install_db_query($edit, "INSERT INTO civicrm_uf_group (domain_id, is_active, form_type, title, help_pre, help_post) VALUES (1,1,NULL,'CiviCRM Volunteer Profile',NULL,NULL)");
  _install_db_query($edit, "INSERT INTO civicrm_uf_group (domain_id, is_active, form_type, title, help_pre, help_post) VALUES (1,1,NULL,'Address',NULL,NULL)");
  
  _install_db_query($edit, "INSERT INTO civicrm_uf_field (uf_group_id, field_name, is_active, is_view, is_required, weight, help_post, visibility, in_selector) VALUES (1,'first_name',1,0,1,1,'','User and User Admin Only',1)");
  _install_db_query($edit, "INSERT INTO civicrm_uf_field (uf_group_id, field_name, is_active, is_view, is_required, weight, help_post, visibility, in_selector) VALUES (1,'last_name',1,0,1,2,'','Public User Pages and Listings',1)");
  _install_db_query($edit, "INSERT INTO civicrm_uf_field (uf_group_id, field_name, is_active, is_view, is_required, weight, help_post, visibility, in_selector, location_type_id) VALUES (1,'email',1,0,1,3,'','User and User Admin Only',1,1)");
  
  _install_db_query($edit, "INSERT INTO civicrm_uf_field (uf_group_id, field_name, is_active, is_view, is_required, weight, help_post, visibility, in_selector, location_type_id) VALUES (2,'street_address',1,0,0,1,'','User and User Admin Only',0,1)");
  _install_db_query($edit, "INSERT INTO civicrm_uf_field (uf_group_id, field_name, is_active, is_view, is_required, weight, help_post, visibility, in_selector, location_type_id) VALUES (2,'supplemental_address_1',1,0,0,2,'','User and User Admin Only',0,1)");
  _install_db_query($edit, "INSERT INTO civicrm_uf_field (uf_group_id, field_name, is_active, is_view, is_required, weight, help_post, visibility, in_selector, location_type_id) VALUES (2,'city',1,0,0,3,'','User and User Admin Only',0,1)");
  _install_db_query($edit, "INSERT INTO civicrm_uf_field (uf_group_id, field_name, is_active, is_view, is_required, weight, help_post, visibility, in_selector, location_type_id) VALUES (2,'state_province',1,0,0,4,'','User and User Admin Only',0,1)");
  _install_db_query($edit, "INSERT INTO civicrm_uf_field (uf_group_id, field_name, is_active, is_view, is_required, weight, help_post, visibility, in_selector, location_type_id) VALUES (2,'postal_code',1,0,0,5,'','User and User Admin Only',0,1)");
  _install_db_query($edit, "INSERT INTO civicrm_uf_field (uf_group_id, field_name, is_active, is_view, is_required, weight, help_post, visibility, in_selector, location_type_id) VALUES (2,'country',1,0,0,6,'','User and User Admin Only',0,1)");
  
  _install_db_query($edit, "INSERT INTO civicrm_uf_join (is_active, module, entity_table, entity_id, weight, uf_group_id) VALUES (1,'User Account',NULL,NULL,3,2)");
  _install_db_query($edit, "INSERT INTO civicrm_uf_join (is_active, module, entity_table, entity_id, weight, uf_group_id) VALUES (1,'Profile',NULL,NULL,1,1)");
  _install_db_query($edit, "INSERT INTO civicrm_uf_join (is_active, module, entity_table, entity_id, weight, uf_group_id) VALUES (1,'User Account',NULL,NULL,1,1)");
  
  _install_db_query($edit, "INSERT INTO civicrm_group (domain_id, name, title, description, source, saved_search_id, is_active, visibility) VALUES (1,'Volunteer_Group','Volunteer Group','For Volunteer Module Usage',NULL,NULL,1,'User and User Admin Only')");
  _install_db_query($edit, "INSERT INTO civicrm_saved_search (domain_id, query, form_values, is_active) VALUES (1,NULL,'a:6:{s:12:\"contact_type\";s:0:\"\";s:5:\"group\";s:0:\"\";s:3:\"tag\";s:0:\"\";s:9:\"sort_name\";s:0:\"\";s:4:\"task\";s:2:\"16\";s:8:\"radio_ts\";s:6:\"ts_all\";}',1)");
  _install_db_query($edit, "INSERT INTO civicrm_group (domain_id, name, title, description, source, saved_search_id, is_active, visibility) VALUES (1,'All_CiviCRM_contacts','All CiviCRM contacts','foo',NULL,1,1,'User and User Admin Only')");
  
  _install_db_query($edit, 'INSERT INTO variable (name, value) VALUES ("volunteer_form", \'s:1:"1";\')');
  _install_db_query($edit, 'INSERT INTO variable (name, value) VALUES ("volunteer_contact_source", \'s:1:"1";\')');
  _install_db_query($edit, "INSERT INTO phplist_list (name, description, listorder, active, public, owner) VALUES ('All contacts', 'This list is a list to which all your contacts get subscribed.', '0', '1', '1', '1')");
  _install_db_query($edit, "INSERT INTO phplist_civicrm_groups (lid, gid) VALUES (1, 2)");
  
}

function _install_looks_like_civicrm_query($query) {
  $query_lo = strtolower($query);
  
  if (preg_match('/^create table civicrm_/', $query_lo)) {
    return TRUE;
  }
  
  if (preg_match('/^drop table if exists civicrm_/', $query_lo)) {
    return TRUE;
  }
  
  if (preg_match('/^insert into civicrm_/', $query_lo)) {
    return TRUE;
  }
  
  if (preg_match('/^replace into civicrm_/', $query_lo)) {
    return TRUE;
  }
  
  if (preg_match('/^update civicrm_/', $query_lo)) {
    return TRUE;
  }
  
  return FALSE;
}

// *************************************************************************************
// This is where the actual HTTP requests of the install procedure actually
// start getting processed.  Everything above this are function defs for
// functions that are referenced below.
// *************************************************************************************

include_once('sites/default/settings.php');
ini_set('session.save_handler', 'files');

if (install_conf_written_before() && $_POST['op'] != 'Try checks again') {
  print install_already_installed_page();
  exit;
}

session_start();

$op = isset($_POST['op']) ? $_POST['op'] : NULL;
$op = $op ? $op : (isset($_GET['op']) ? $_GET['op'] : NULL);

if (!$op) {
  print install_step_page('Introduction');
}
else {
  switch ($op) {
    // Some clients (browsers) might send back a "\'" "'"
    case "Begin installation":
    case 'Try again':
      print install_step_page('Server check-up');
      session_destroy();
      break;
    case 'Install':
      print install_step_page('Install');
      break;
    case 'Setup database':
      // case 'Configure database':
      print install_step_page('Database setup');
      break;
    case 'Create tables':
    case 'Retry table creation':
      $edit = $_POST['edit'];
      $failed_message = '';
      if (install_test_dbinfo($edit, $failed_message)) {
        global $db_url;
        $db_url['default'] = $edit['db_type'] .'://'. $edit['db_user'] .':'. $edit['db_pass'] .'@'. $edit['db_host'] .'/'. $edit['db_db'];
        $db_url['civicrm'] = $edit['db_type'] .'://'. $edit['db_user_civicrm'] .':'. $edit['db_pass_civicrm'] .'@'. $edit['db_host_civicrm'] .'/'. $edit['db_db_civicrm'];
        $db_prefix = $edit['db_prefix'];
        //install_create_tables($edit);
        _install_dump_and_serve($edit);
        //install_write_conf($edit);
        //print install_step_page('Finishing up');
      }
      else {
        print install_step_page('Database setup');
      }
      break;
    case 'Try checks again':
    case 'Cancel installation':
      print install_step_page('Finishing up');
      break;
    case 'continue_dump':
      $edit['multisite_setup'] = $_SESSION['multisite_setup'];
      $edit['civicontribute'] = $_SESSION['civicontribute'];
//      $edit['civimail'] = $_SESSION['civimail'];
      $edit['db_user'] = $_SESSION['db_user'];
      $edit['db_pass'] = $_SESSION['db_pass'];
      $edit['db_host'] = $_SESSION['db_host'];
      $edit['db_db'] = $_SESSION['db_db'];
      $edit['db_prefix'] = $_SESSION['db_prefix'];
      $edit['db_user_civicrm'] = $_SESSION['db_user_civicrm'];
      $edit['db_pass_civicrm'] = $_SESSION['db_pass_civicrm'];
      $edit['db_host_civicrm'] = $_SESSION['db_host_civicrm'];
      $edit['db_db_civicrm'] = $_SESSION['db_db_civicrm'];
      $edit['db_type'] = $_SESSION['db_type'];
      $edit['mysql_version_confirmed'] = $_SESSION['mysql_version_confirmed'];
      $edit['use_us_zipcodes'] = $_SESSION['use_us_zipcodes'];
      $edit['google_map'] = $_SESSION['google_map'];
      $edit['install_docs'] = $_SESSION['install_docs'];
      global $db_url;
      $db_url['default'] = $edit['db_type'] .'://'. $edit['db_user'] .':'. $edit['db_pass'] .'@'. $edit['db_host'] .'/'. $edit['db_db'];
      $db_url['civicrm'] = $edit['db_type'] .'://'. $edit['db_user_civicrm'] .':'. $edit['db_pass_civicrm'] .'@'. $edit['db_host_civicrm'] .'/'. $edit['db_db_civicrm'];
      if (!isset($_SESSION['continue_dump']) || !$_SESSION['continue_dump']) {
        header('Location: http://'. install_base_uri() .'/install.php');
        exit();
      }
      _install_dump_and_serve($edit);
      break;
  }
}


?>
