<?php
// $Id: import_event.inc,v 1.5 2005/07/01 23:06:53 drumm Exp $

function event_node_import_fields($type) {
  if (event_is_enabled($type)) {
    $fields = array('startdate' => t('Start date'),
                    'enddate' => t('End date'));
    return $fields;
  }
}

function event_node_import_prepare(&$node, $preview = FALSE) {
  foreach (array('start', 'end') as $what) {
    $whatdate = $what .'date';
    if (isset($node->$whatdate)) {
      if (($time = strtotime($node->$whatdate)) == -1) {
        form_set_error($whatdate, t('Date is in an unrecognisable format, for example use "9/24/2005 8:02pm"'));
      }
      else {
        $time = getdate($time);
        $node->{$what .'year'} = $time['year'];
        $node->{$what .'month'} = $time['mon'];
        $node->{$what .'day'} = $time['mday'];
        $node->{$what .'hour'} = $time['hours'];
        $node->{$what .'minute'} = $time['minutes'];
      }
      unset($node->$whatdate);
    }
  }
}

function event_node_import_global($type) {
  if (event_is_enabled($type)) {
    if (variable_get('event_timezone_input', 'site') == 'input') {
      return form_select(t('Time zone'), 'timezone', event_timezone_map(variable_get('date_default_timezone', 0)), event_zonelist(), t('Select the time zone all imported events occur in.'));
    }
  }
}

function event_node_import_static($type) {
  if (event_is_enabled($type)) {
    if (variable_get('configurable_timezones', 1) && $user->uid && strlen($user->timezone) && (variable_get('event_timezone_input', 'site') == 'user')) {
      return array('event_info' => 1, 'timezone' => event_timezone_map($user->timezone));
    }
    elseif (variable_get('event_timezone_input', 'site') != 'input') {
      return array('event_info' => 1, 'timezone' => event_timezone_map(variable_get('date_default_timezone', 0)));
    }
  }
}

?>
